/* ??? Not required for Ftreefr0.java ???
    _* If including an unlinked root node then create it now *_
    IF AlIncludeUnlinkedRoot THEN
    DO:
        RUN AddNode IN THIS-PROCEDURE
            (INPUT ? _* COM-HANDLE *_,
             INPUT ?,
             INPUT ?,
             INPUT "UnlinkedRoot",
             INPUT AlIncludeUnlinkedRootText,
             INPUT ? 
             ).
    END.
    */

package com.goldencode.hotel.common;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.common.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo._temp.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;
import com.goldencode.p2j.persist.type.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.SelfManager.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/ftreefr0.w).
 */
public class Ftreefr0
{
   Ttnode_1_1.Buf ttnode = SharedVariableManager.addTempTable("ttnode", Ttnode_1_1.Buf.class, "ttnode", "ttNode");

   Ftreefr0Ftreeviewparent ftreeviewparentFrame = GenericFrame.createFrame(Ftreefr0Ftreeviewparent.class, "ftreeviewparent");

   /* ***************************  Definitions  ************************** */   
   /* Parameters Definitions ---                                           */   
   character goisDebug = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "goisdebug", true, new character(""));

   handle ghDebugWindowProc = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "ghdebugwindowproc", true, new handle());

   /* Local Variable Definitions ---                                       */   
   character lCUibmode = TypeFactory.character();

   /* Images for nodes default to 1 and 2 - can change with {set} on AiImage/AiSelectedImage */   
   integer aiImage = TypeFactory.integer((long) 1);

   integer aiSelectedImage = TypeFactory.integer((long) 2);

   integer aiLeafImage = TypeFactory.integer((long) 3);

   integer aiLeafSelImage = TypeFactory.integer((long) 4);

   logical alSecurityCheck = TypeFactory.logical();

   logical alTreeInitialized = TypeFactory.logical(false);

   /* Signal whether we're in 'SmartDataBrowse' mode i.e. with a data source
      object which we 'browse' using the tree */   
   logical llSdbmode = TypeFactory.logical(false);

   character acIdFieldName = TypeFactory.character();

   character acparentIdFieldName = TypeFactory.character();

   character acTextFieldName = TypeFactory.character();

   character acAutoExpandSingleRoot = TypeFactory.character();

   logical alAutoExpandAllNodes = TypeFactory.logical(false);

   character acSurveyCode = TypeFactory.character();

   character acSurveyDesc = TypeFactory.character();

   character acSurveyActive = TypeFactory.character();

   character acLevelActive = TypeFactory.character();

   character acLevelLeaf = TypeFactory.character();

   handle lhLevelData = TypeFactory.handle();

   handle acLevelHandle = TypeFactory.handle();

   character lcIdList = TypeFactory.character();

   handle lhContainerSource = TypeFactory.handle();

   character lcCurrentSet = TypeFactory.character();

   character lcOldSet = TypeFactory.character();

   character lcNodeKey = TypeFactory.character();

   character lcLevelCode = TypeFactory.character();

   character lcTreeMode = TypeFactory.character();

   /* Unlinked root is allowed when acting as a SmartDataBrowser. The attribute
      allows the container to specify that a root node should be created which
      will parent all other (record) nodes, but will not be linked to a record
      itself. The data-source must handle this in fetchRowIdent, to which a
      RowIdent of 'UnlinkedRoot' will be passed.
   */   
   logical alIncludeUnlinkedRoot = TypeFactory.logical(false);

   character alIncludeUnlinkedRootText = TypeFactory.character("Surveys for Set");

   logical alAutoSelectRootNodeOnOpen = TypeFactory.logical(true);

   character lcCurrentRowIdent = TypeFactory.character();

   logical llTransactionCompleted = TypeFactory.logical(false);

   handle lhClientFunctionsSuperProcedure = TypeFactory.handle();

   HandleExpr0 handleExpr0 = new HandleExpr0();

   HandleExpr1 handleExpr1 = new HandleExpr1();

   HandleExpr2 handleExpr2 = new HandleExpr2();

   HandleExpr3 handleExpr3 = new HandleExpr3();

   HandleExpr4 handleExpr4 = new HandleExpr4();

   HandleExpr5 handleExpr5 = new HandleExpr5();

   /* These preprocessors tell at compile time which properties can be
        retrieved directly from the temp-table. */   
   /* This property contains the security for all objects found in the AllFieldHandles Property */    
   /* Include the next property file up the chain (in this case, the top
        of the chain); it starts the property temp-table definition and we
        add our field definitions to it. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver /* quick access to all handles on object, e.g. viewer, whether enabled or not */  /* quick access to all fields on object, e.g. viewer, whether enabled or not */ = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /* Include Layout Manager support. This is done here rather than in
      the procedure settings method libraries so colayosup0.p appears on
      top of the super procedure stack
   */   
   /* Blank version of alayoml0.i */   
   /* _UIB-CODE-BLOCK-END */   
   /*------------------------------------------------------------------------
   Description:    Method Library Template
   Arguments:      <none>
   Comments:       
       Builds a treeview from a temp-table. Just need a frame to parent the treeview into
                   
       Expects that the temp-table is already fully built (doesn't currently support lazy loading of the data)
       
       The node id can be any datatype - normally expecting to be a character or integer.
       Note the variable names assume character (e.g. cNodeId)
       
       Use the following preprocessors if necessary in the parent procedure to override the defaults
       
   &GLOBAL-DEFINE ttNode <Temp-Table>
   &GLOBAL-DEFINE id_dataType <id field DataType>    
   &GLOBAL-DEFINE id <id field>
   &GLOBAL-DEFINE parentId <parent id field>
   &GLOBAL-DEFINE nodeText <field to be used as node text>
   &GLOBAL-DEFINE fTreeViewParent <frame to place the treeview in>
       
       NB.  The following fields need to be added to the temp-table:
       
       FIELD nodeTextHandle AS HANDLE
       FIELD nodeOpenerImageHandle AS HANDLE
       FIELD nodeFrameHandle AS HANDLE
       
       potentially, these could be moved to a separate hash-table, and then this method library could be
       used directly on DB tables.  The only link we really need is from the ID to the nodeTextHandle
       anyway.
       
       Enhancements:
           Add leaf node support?  E.g. specify logic to determine if a leaf node. 
               Currently empty parents are by default shown as leaf documents.
             
   ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Parameters Definitions ---                                           */   
   /* Preprocessor Defaults */   
   /* CAST_id function - converts from a CHARACTER to whatever the id datatype is. */   
   /* If Progress had a "CHARACTER" function instead of "STRING", then this wouldn't be necessary - would always use the datatype as a CAST */   
   character lcTreeVirtualRootNodeId = TypeFactory.character();

   /* The virtual parent of all the displayed nodes - normally <blank>, associated with the <root> frame */   
   handle lhTreeSelectedText = TypeFactory.handle();

   handle lhTreeFocusPixelButton = TypeFactory.handle();

   /* Where the focus resides when the treeview is in use */   
   handle lhTreeFocusSwapPixelButton = TypeFactory.handle();

   Ttnode_1_1.Buf ttnodeBuf7;

   Ttnode_1_1.Buf ttnodeBuf11;

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/ftreefr0.w).
    */
   public void execute()
   {
      /* For {get/set} */
      handle ghAdmprops = TypeFactory.handle();
      /* Handle of prop t-t */
      handle ghAdmpropsBuf = TypeFactory.handle();
      /*  and its buffer    */
      logical glAdmloadFromRepos = TypeFactory.logical();
      /* _UIB-CODE-BLOCK-END */
      /* _UIB-CODE-BLOCK-END */
      /* ********************  Preprocessor Definitions  ******************** */
      /* _UIB-PREPROCESSOR-BLOCK-END */
      /* *********************** Procedure Settings ************************ */
      /* Settings for THIS-PROCEDURE
         Type: Method-Library
         Allow: 
         Frames: 0
         Add Fields to: Neither
         Other Settings: INCLUDE-ONLY
       */
      /* *************************  Create Window  ************************** */
      /* DESIGN Window definition (used by the UIB) 
        CREATE WINDOW Method-Library ASSIGN
               HEIGHT             = 7.86
               WIDTH              = 60.
      _* END WINDOW DEFINITION *_
                                                                              */
      /* ************************* Included-Libraries *********************** */
      /* If this container has no visualization 
         -- is either defined to be 'virtual' or is a SmartFrame with no frame --
         (This can be used simply by opening a SmartFrame and deleting the frame.) 
         If virtual then it is simply a container for non-visual objects; 
         so skip visual.i, and include smart.i or appserver.i depending on the  
         appserver aware preprocessor defined for Appserver aware objects in 
         adecomm/appserv.i */
      /*********************************************************************
      * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
      * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
      * below.  All Rights Reserved.                                       *
      *                                                                    *
      * The Initial Developer of the Original Code is PSC.  The Original   *
      * Code is Progress IDE code released to open source December 1, 2000.*
      *                                                                    *
      * The contents of this file are subject to the Possenet Public       *
      * License Version 1.0 (the "License"); you may not use this file     *
      * except in compliance with the License.  A copy of the License is   *
      * available as of the date of this notice at                         *
      * http://www.possenet.org/license.html                               *
      *                                                                    *
      * Software distributed under the License is distributed on an "AS IS"*
      * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
      * should refer to the License for the specific language governing    *
      * rights and limitations under the License.                          *
      *                                                                    *
      * Contributors:                                                      *
      *                                                                    *
      *********************************************************************/
      /*--------------------------------------------------------------------------
          File        : visual.i
          Purpose     : Defines basic properties and other info for visual objects
      
          Syntax      :
      
          Description :
      
          Modified    : May 19, 1999 Version 9.1A
          Modified    : 11/13/2001      Mark Davies (MIP)
                        Check for valid handle of any gsh... variables
        ------------------------------------------------------------------------*/
      /*          This .i file was created with the Progress UIB.             */
      /*----------------------------------------------------------------------*/
      /* ***************************  Definitions  ************************** */
      /* _UIB-CODE-BLOCK-END */
      /* ********************  Preprocessor Definitions  ******************** */
      /* _UIB-PREPROCESSOR-BLOCK-END */
      /* *********************** Procedure Settings ************************ */
      /* Settings for THIS-PROCEDURE
         Type: Include
         Allow: 
         Frames: 0
         Add Fields to: Neither
         Other Settings: INCLUDE-ONLY
       */
      /* *************************  Create Window  ************************** */
      /* DESIGN Window definition (used by the UIB) 
        CREATE WINDOW Include ASSIGN
               HEIGHT             = 8
               WIDTH              = 60.
      _* END WINDOW DEFINITION *_
                                                                              */
      /* ************************* Included-Libraries *********************** */
      /*********************************************************************
      * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
      * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
      * below.  All Rights Reserved.                                       *
      *                                                                    *
      * The Initial Developer of the Original Code is PSC.  The Original   *
      * Code is Progress IDE code released to open source December 1, 2000.*
      *                                                                    *
      * The contents of this file are subject to the Possenet Public       *
      * License Version 1.0 (the "License"); you may not use this file     *
      * except in compliance with the License.  A copy of the License is   *
      * available as of the date of this notice at                         *
      * http://www.possenet.org/license.html                               *
      *                                                                    *
      * Software distributed under the License is distributed on an "AS IS"*
      * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
      * should refer to the License for the specific language governing    *
      * rights and limitations under the License.                          *
      *                                                                    *
      * Contributors:                                                      *
      *                                                                    *
      *********************************************************************/
      /*--------------------------------------------------------------------------
          Library     : smart.i - NEW V9 version of top-level SmartObject include
      
          Modified    : May 22, 2000 -- Version 9.1B
        ------------------------------------------------------------------------*/
      /*          This .i file was created with the Progress UIB.             */
      /*----------------------------------------------------------------------*/
      /* ***************************  Definitions  ************************** */
      /* If smart.i has already been included, skip everything 
            (matching ENDIF is at the end of the file). */
      /* Define the preprocessor that identifies the basic "class" of the object;
           ADMClass will remain undefined here only if the object uses no sub-class
           include files. */
      /* If this object is of type "smart", i.e., uses no lower class include
           files, then include the property file here. Otherwise this will be
           done in the class include file of the base class of the object. */
      /* Window or Frame handle (not used, but kept for backwards comaptibility) */
      handle ghContainer = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      integer iStart = TypeFactory.integer();
      
      externalProcedure(Ftreefr0.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         ProcedureManager.registerFunctionHandle("FcCalculateStringValue", handleExpr5);
         ProcedureManager.registerFunctionHandle("FcOrderStringList", handleExpr4);
         ProcedureManager.registerFunctionHandle("FlIsExistingDirectory", handleExpr3);
         ProcedureManager.registerFunctionHandle("FcClearCombo", handleExpr2);
         ProcedureManager.registerFunctionHandle("FcString_RemoveNonNumeric", handleExpr1);
         ProcedureManager.registerFunctionHandle("FcConvDataType", handleExpr0);
         RecordBuffer.openScope(ttnode);
         /*------------------------------------------------------------------------
           File: sdbtreeview.w
           Description: SmartObject wrapper for treeview control from Microsoft
                        This tree can act effectively as a SmartDataBrowser but
                        with a tree view of the records. e.g. Area tree, users tree etc
                        
                        Currently uses MS TreeView V6.0
           Notes: Use this control to show a tree and respond to events from it
           
                  The tree is created by calling the Add internal procedure to add
                  nodes to the tree control.
                  You can check which node is selected at any time by querying the
                  attribute 'AcSelectedItemKey' which returns the key of the selected
                  node.
                  
                  You can respond to the user double clicking on a leaf node by 
                  subscribing to the event 'TreeDblClickLeaf'. The internal procedure
                  fired must take a single char parameter which will be the key of
                  the node clicked. This subscribe can be done easily by adding a
                  SmartLink of type 'TreeDblClickLeaf' from this SmartObject to 
                  another SmartObject and coding a procedure within the taret object
                  called 'TreeDblClickLeaf' (with the single char input parameter).
                  SmartDataBrowserTree functionality
                  ----------------------------------
                 
                 The tree in this instance has a data source of fsurvdo0.w.
                 This provides the survey record level of the view, which is 
                 the first 'level'. For each survey, it gets all the levels 
                 for the survey from flevldo0.w in BuildTreeTable.And build
                 accordingly
                 The container tells the tree which fields are responsible 
                 for what by setting functions and then retrieving them 
                 in the build.
                    
                    Survey Attributes
                    {set AcSurveyCode 'fsurvey_code' h_ftreefr0}.
                    {set AcSurveyDesc  'dsc' h_ftreefr0}.
                    {set AcSurveyActive  'active' h_ftreefr0}. 
                    
                    Level Attributes
                    {set AcIdFieldName 'flevel_code' h_ftreefr0}.
                    {set AcparentIdFieldName 'parent_flevel_code' h_ftreefr0}.
                    {set AcTextFieldName 'dsc' h_ftreefr0}.
                    {set AcLevelActive 'activelevel' h_ftreefr0}. 
                    {set AcLevelLeaf    'leaf' h_ftreefr0}.
              
                  
                  These settings are to tell the tree the field names for
                  - The 'id' field name i.e. The field uniquely identifying the record
                    and also the field which relates to the reflexive relationship on
                    the table (i.e. it joins to AcparentIdFieldName
                  - The 'parentId' field name, which joins to id as discussed
                  - The 'text' field name which is used to populate the text on each node
                  
                  NOTE: This object must be initialised after the SDO object to which
                        it is linked (i.e. must be lower on the frame of the container)
                  
                 
                  Still Outstanding
                  -----------------
                  - Single clicking (TreeClick event/link)
                  - Context menu (currently some code commented out in initializeObject
                    and OCX.MouseDown. Have to use an API call to show the context menu
                    but apart from that looked OK - had to left click then right click
                    to select a node then get the context menu for it which looked a
                    bit strange). Probably best to let the developer generate a context 
                    menu in their code then assign the FRAME {&FRAME-NAME}:MENU to this
                    menu handle.
          
             
          
          
         ------------------------------------------------------------------------*/
         /*          This .W file was created with the Progress AppBuilder.      */
         /*----------------------------------------------------------------------*/
         /* Create an unnamed pool to store all the widgets created 
              by this procedure. This is a good default which assures
              that this procedure's triggers and internal procedures 
              will execute in this procedure's storage, and that proper
              cleanup will occur on deletion of the procedure. */
         WidgetPool.create();
         
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: SmartFrame
            Allow: Basic,Browse,DB-Fields,Query,Smart
            Container Links: Data-Target,Data-Source,Page-Target
            Other Settings: PERSISTENT-ONLY
          */
         /* This procedure should always be RUN PERSISTENT.  Report the error,  */
         /* then cleanup and return.                                            */
         if (_not(thisProcedure().unwrapProcedure().isPersistent()))
         {
            messageBox("common/ftreefr0.w should only be RUN PERSISTENT.", ALERT_ERROR, BTN_OK, (String) null);
            returnNormal();
         }
         
         if (_not(lhClientFunctionsSuperProcedure.isValid()))
         {
            lhClientFunctionsSuperProcedure.assign(ProcedureManager.firstProcedure());
            
            loopLabel1:
            while (_and(lhClientFunctionsSuperProcedure.isValid(), () -> isNotEqual(lhClientFunctionsSuperProcedure.unwrapFile().getFileName(), "aclifli0.p")))
            {
               lhClientFunctionsSuperProcedure.assign(lhClientFunctionsSuperProcedure.unwrap().getNextSibling());
            }
            
            if (_not(lhClientFunctionsSuperProcedure.isValid()))
            {
               ControlFlowOps.invokePersistentSet("aclifli0.p", lhClientFunctionsSuperProcedure);
            }
            
            thisProcedure().unwrapCommonProcedure().addSuperProcedure(lhClientFunctionsSuperProcedure, ProcedureManager.SEARCH_TARGET);
         }
         
         /*********************************************************************
         * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
         * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
         * below.  All Rights Reserved.                                       *
         *                                                                    *
         * The Initial Developer of the Original Code is PSC.  The Original   *
         * Code is Progress IDE code released to open source December 1, 2000.*
         *                                                                    *
         * The contents of this file are subject to the Possenet Public       *
         * License Version 1.0 (the "License"); you may not use this file     *
         * except in compliance with the License.  A copy of the License is   *
         * available as of the date of this notice at                         *
         * http://www.possenet.org/license.html                               *
         *                                                                    *
         * Software distributed under the License is distributed on an "AS IS"*
         * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
         * should refer to the License for the specific language governing    *
         * rights and limitations under the License.                          *
         *                                                                    *
         * Contributors:                                                      *
         *                                                                    *
         *********************************************************************/
         /*-------------------------------------------------------------------------
             Library     : containr.i  
             Purpose     : Default V9 Main Block code and Method Procedures
                           for ADM Container procedures.
           
             Syntax      : {src/adm2/containr.i}
         
             Modified    : February 18, 2001 Version 9.1C 
             
             Note: !!!   : Method Libraries are maintained manually for 
                           conditional inclusion.        
         -------------------------------------------------------------------------*/
         /***********************  DEFINITIONS  ***********************************/
         /* If this is a SmartFrame with no Frame, then re-identify it as a 'virtual'
            -- i.e, non-visual -- container. */
         /* make the window's max size the session size, but do it no-error 
            as window-name may be current-window with no window (serverside sbo) */
         /* Avoid this if current-window = {Window-name} already. (a suppressed window) */
         /* The current-window will be set to {&window-name} later for a normal window */
         if (_isNotEqual(currentWindow(), currentWindow()))
         {
            /* only change if the max-width is default */
            if (_isEqual(currentWindow().unwrapWindow().getMaxWidth(), currentWindow().unwrapWidget().getVirtWidth()))
            {
               ErrorManager.silentErrorEnable();
               currentWindow().unwrapWindow().setMaxWidth(minus(LogicalTerminal.getWidthChars(), 1));
               ErrorManager.silentErrorDisable();
            }
            
            /* only change if the max-height is default */
            if (_isEqual(currentWindow().unwrapWindow().getMaxHeight(), currentWindow().unwrapWidget().getVirtHeight()))
            {
               ErrorManager.silentErrorEnable();
               currentWindow().unwrapWindow().setMaxHeight(minus(LogicalTerminal.getHeightChars(), 1));
               ErrorManager.silentErrorDisable();
            }
         }
         
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         /* Note that adm-props-from-repository is intended to be replaced with
              a variable for flexible override, so it cannot be used for conditional 
              compile.  */
         if ((gshRepositoryManager.isValid()).booleanValue())
         {
            if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode("prepareInstance", gshRepositoryManager, "II", concat(valueOf(thisProcedure()), ",", valueOf(ftreeviewparentFrame.asWidgetHandle())), sourceProcedure()))))
            {
               stop();
            }
            
            ghAdmpropsBuf.assign(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))));
            glAdmloadFromRepos.assign(ghAdmpropsBuf.isValid());
         }
         
         /* VALID-HANDLE(gshRepositoryManager) */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            TempTableBuilder.create(ghAdmprops);
            ghAdmprops.unwrapTempTable().setCanUndo(new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectName"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectVersion"), new character("CHAR"), new integer(0), new character(), new character("ADM2.2"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectType"), new character("CHAR"), new integer(0), new character(), new character("SmartFrame"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerType"), new character("CHAR"), new integer(0), new character(), new character("FRAME"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PropertyDialog"), new character("CHAR"), new integer(0), new character(), new character("adm2/support/visuald.w"));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryObject"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerHandle"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceProperties"), new character("CHAR"), new integer(0), new character(), new character("LogicalObjectName,PhysicalObjectName,DynamicObject,RunAttribute, HideOnInit,DisableOnInit,ObjectLayout"));
            /* NOTE: Any need to support &User-Supported-Links?? */
            ghAdmprops.unwrapTempTable().addNewField(new character("SupportedLinks"), new character("CHAR"), new integer(0), new character(), new character("Data-Target,Data-Source,Page-Target"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerHidden"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectInitialized"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            /*  "hidden" is a logical concept. */
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectHidden"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("HideOnInit"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("UIBMode"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerSource"), new character("HANDLE"));
            /* Note that datavis adds some events that are only required for updating objects */
            /* isUpdateActive event is needed only for data, datavis and container classes,
                 but we currently define it here.. (this simplifies the logic for datavis, 
                 which may or may not inherit from container)
                 confirmOk and confirmCancel only for container ans datavis */
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("initializeObject,hideObject,viewObject,destroyObject,enableObject,confirmExit,confirmCancel,confirmOk,isUpdateActive"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSource"), new character("HANDLE"));
            /* Note that DataSourceEvents is overidden in data.i since some of these 
                 events are intended for visual targets; queryPosition, fetchDataSet, 
                 assignMaxdataguess and the most resent addition confirmUndo and 
                 confirmCommit. These two are NOT dataSourceEvents for SDOs as the message 
                 should not to be published to objects not affected by the commit/undo. */
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("dataAvailable,queryPosition,updateState,deleteComplete,fetchDataSet,confirmContinue,confirmCommit,confirmUndo,assignMaxGuess,isUpdatePending"));
            ghAdmprops.unwrapTempTable().addNewField(new character("TranslatableProperties"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectPage"), new character("INT"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("DBAware"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("DesignDataObject"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSourceNames"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataTargetEvents"), new character("CHARACTER"), new integer(0), new character(), new character("updateState,rowObjectState,fetchBatch,LinkState"));
            ghAdmprops.unwrapTempTable().addNewField(new character("LogicalObjectName"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalObjectName"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("LogicalVersion"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalVersion"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DynamicObject"), new character("LOGICAL"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RunAttribute"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ChildDataKey"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ParentDataKey"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataLinksEnabled"), new character("LOGICAL"), new integer(), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("InactiveLinks"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceId"), new character("DECIMAL"));
            /* SuperProcedure management */
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedureMode"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedureHandle"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutPosition"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ClassName"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RenderingProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ThinRenderingProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("Label"), new character("CHAR"), new integer(0), new character(), new unknown());
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* else if appserver aware (adecomm/appserv.i) include appserver props */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectLayout"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutOptions"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectEnabled"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutVariable"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DefaultLayout"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DisableOnInit"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("EnabledObjFlds"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("EnabledObjHdls"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("FieldSecurity"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("SecuredTokens"), new character("CHARACTER"), new integer(0), new character(), new unknown());
            /* Initial must be unknown. */
            ghAdmprops.unwrapTempTable().addNewField(new character("AllFieldHandles"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("AllFieldNames"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("MinHeight"), new character("DECIMAL"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("MinWidth"), new character("DECIMAL"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("ResizeHorizontal"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ResizeVertical"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectSecured"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectTranslated"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("PopupButtonsInFields"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorInfoBG"), new character("INTEGER"), new integer(0), new character(), new integer(10));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorInfoFG"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorWarnBG"), new character("INTEGER"), new integer(0), new character(), new integer(3));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorWarnFG"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorErrorBG"), new character("INTEGER"), new integer(0), new character(), new integer(12));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorErrorFG"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("BGColor"), new character("INTEGER"), new integer(0), new character(), new integer(12));
            ghAdmprops.unwrapTempTable().addNewField(new character("FGColor"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FieldPopupMapping"), new character("CHARACTER"), new integer(0), new character(), new character(""));
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            ghAdmprops.unwrapTempTable().addNewField(new character("CurrentPage"), new character("INT"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("PendingPage"), new character("INT"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerTargetEvents"), new character("CHAR"), new integer(0), new character(), new character("exitObject,okObject,cancelObject,updateActive"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerToolbarSource"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerToolbarSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("toolbar,okObject,cancelObject"));
            ghAdmprops.unwrapTempTable().addNewField(new character("OutMessageTarget"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PageNTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("PageSource"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("FilterSource"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdateSource"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdateTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitSource"), new character("HANDLE"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("commitTransaction,undoTransaction"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitTargetEvents"), new character("CHAR"), new integer(0), new character(), new character("rowObjectState"));
            ghAdmprops.unwrapTempTable().addNewField(new character("StartPage"), new character("INT"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("RunMultiple"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("WaitForObject"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DynamicSDOProcedure"), new character("CHAR"), new integer(0), new character(), new character("adm2/dyndata.w"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RunDOOptions"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("InitialPageList"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            /* comma delimited list of pages to construct at startup or * for all or empty for just start page and page 0 */
            ghAdmprops.unwrapTempTable().addNewField(new character("WindowFrameHandle"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("Page0LayoutManager"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("MultiInstanceSupported"), new character("LOGICAL"), new integer(), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("MultiInstanceActivated"), new character("LOGICAL"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerMode"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SavedContainerMode"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SdoForeignFields"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("NavigationSource"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("NavigationTarget"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PrimarySdoTarget"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("NavigationSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("fetchFirst,fetchNext,fetchPrev,fetchLast,startFilter"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CallerWindow"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CallerProcedure"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CallerObject"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DisabledAddModeTabs"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ReEnableDataLinks"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("WindowTitleViewer"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdateActive"), new character("LOGICAL"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectsCreated"), new character("LOGICAL"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceNames"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ClientNames"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainedDataObjects"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainedAppServices"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataContainer"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("HasDynamicProxy"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("HideOnClose"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("HideChildContainersOnClose"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("HasObjectMenu"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("RequiredPages"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RemoveMenuOnHide"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
         }
         
         ghContainer.assign(ftreeviewparentFrame.asWidgetHandle());
         
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 8.62
                  WIDTH              = 52.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ************************* Included-Libraries *********************** */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/smart.p"));
         }
         
         /* Use the old adm definition */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            /* Now create the one record in this property temp-table, and store its
                   handle in ADM-DATA. The CHR(1) delimiters are to set aside spots
                   for UserProperties and UserLinks. */
            ghAdmprops.unwrapTempTable().tempTablePrepare("ADMProps");
            ghAdmpropsBuf.assign(ghAdmprops.unwrapTempTable().defaultBufferHandle());
            ghAdmpropsBuf.unwrapBuffer().bufferCreate();
            /* ... and save it. This ADM object is now open for business! */
            thisProcedure().unwrapADMData().setADMData(concat(valueOf(ghAdmpropsBuf), chr(1), chr(1)));
            /* from this point  {&ADM-PROPS-DEFINED} is true for all cases */
            cObjectName.assign("LogicalObjectName,PhysicalObjectName,DynamicObject,RunAttribute, HideOnInit,DisableOnInit,ObjectLayout");
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
            ghProp.unwrapBufferField().changeValue(cObjectName);
            cObjectName.assign(replaceAll(thisProcedure().unwrapFile().getFileName(), "\\", "/"));
            iStart.assign(plus(lastIndexOf(cObjectName, "/"), 1));
            cObjectName.assign(substring(cObjectName, iStart, minus(lastIndexOf(thisProcedure().unwrapFile().getFileName(), "."), iStart)));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            ghProp.unwrapBufferField().changeValue(cObjectName);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
            ghProp.unwrapBufferField().changeValue(ftreeviewparentFrame.asWidgetHandle());
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
            ghProp.unwrapBufferField().changeValue(new character("SmartFrame"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
            ghProp.unwrapBufferField().changeValue(new character("FRAME"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalVersion"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalObjectName"));
            ghProp.unwrapBufferField().changeValue((_isNotEqual("", "") ? new character("") : thisProcedure().unwrapFile().getFileName()));
         }
         
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/visual.p"));
         }
         
         /* _ADM-CODE-BLOCK-START _CUSTOM _INCLUDED-LIB-CUSTOM CUSTOM */
         /*********************************************************************
         * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
         * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
         * below.  All Rights Reserved.                                       *
         *                                                                    *
         * The Initial Developer of the Original Code is PSC.  The Original   *
         * Code is Progress IDE code released to open source December 1, 2000.*
         *                                                                    *
         * The contents of this file are subject to the Possenet Public       *
         * License Version 1.0 (the "License"); you may not use this file     *
         * except in compliance with the License.  A copy of the License is   *
         * available as of the date of this notice at                         *
         * http://www.possenet.org/license.html                               *
         *                                                                    *
         * Software distributed under the License is distributed on an "AS IS"*
         * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
         * should refer to the License for the specific language governing    *
         * rights and limitations under the License.                          *
         *                                                                    *
         * Contributors:                                                      *
         *                                                                    *
         *********************************************************************/
         /*------------------------------------------------------------------------
             File        : visualcustom.i
             Purpose     : References the start of the custom super procedure.
                           Allows properties initialization.
         
             Syntax      : {src/adm2/custom/visualcustom.i}
         
             Description :
         
             Created     : 06/03/1999
             Notes       : Referenced in {src/adm2/visual.i}
           ----------------------------------------------------------------------*/
         /*          This .W file was created with the Progress AppBuilder.      */
         /*----------------------------------------------------------------------*/
         /* ***************************  Definitions  ************************** */
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Include
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Include ASSIGN
                  HEIGHT             = 15
                  WIDTH              = 60.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Starts here the custom super procedure 
            Uncomment to run it */
         /*RUN start-super-proc ("adm2/custom/visualcustom.p":U).*/
         /* _UIB-CODE-BLOCK-END */
         /* _ADM-CODE-BLOCK-END */
         if ((gshSessionManager.isValid()).booleanValue())
         {
            registerTrigger(new EventList("HELP", ftreeviewparentFrame.asWidget(), true), Ftreefr0.this, new Trigger((Body) () -> 
            {
               ControlFlowOps.invokeInWithMode("contextHelp", gshSessionManager, "II", thisProcedure(), focus());
            }));
         }
         
         registerTrigger(new EventList("CTRL-PAGE-UP", ftreeviewparentFrame.asWidget(), true), Ftreefr0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeInWithMode("processAction", targetProcedure(), "I", new character("CTRL-PAGE-UP"));
         }));
         
         registerTrigger(new EventList("CTRL-PAGE-DOWN", ftreeviewparentFrame.asWidget(), true), Ftreefr0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeInWithMode("processAction", targetProcedure(), "I", new character("CTRL-PAGE-DOWN"));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/containr.p"));
            ControlFlowOps.invokeInWithMode("modifyListProperty", targetProcedure(), "IIII", targetProcedure(), new character("Add"), new character("ContainerSourceEvents"), new character("initializeDataObjects"));
            
            /* {fn <func-name> [handle] */ 
            if (_not(matchesList(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getSupportedLinks", targetProcedure()), "containertoolbar-target")))
            {
               ControlFlowOps.invokeInWithMode("modifyListProperty", targetProcedure(), "IIII", targetProcedure(), new character("Add"), new character("SupportedLinks"), new character("ContainerToolbar-Target"));
            }
         }
         /* if not adm-load-from-repos */
         /* Best default for GUI applications - this will apply to the whole session: */
         pauseBeforeHide(0);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowFrameHandle"));
         ghProp.unwrapBufferField().changeValue(ftreeviewparentFrame.asWidgetHandle());
         /* _UIB-CODE-BLOCK-END */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         /* Start SDO OIS Super procedure */
         ControlFlowOps.invokeWithMode("POISStartSuperProc", "I", new character("ascnsup0.p"));
         
         /* Used in "trick" to force the frame to reposition when using cursor to move selected row */
         /* Check to see if this is included in something else, if not, define dummy frame and temp-table */
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 9.81
                  WIDTH              = 38.72.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ************************* Included-Libraries *********************** */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         /* Ensure focus in {&fTreeViewParent} always go to the button - so user can tab off */
         registerTrigger(new EventList("ENTRY", ftreeviewparentFrame.asWidget(), true), Ftreefr0.this, new Trigger((Body) () -> 
         {
            if ((lhTreeFocusPixelButton.isValid()).booleanValue())
            {
               apply(lhTreeFocusPixelButton, "ENTRY");
            }
         }));
      }));
   }

   /** define functions for returning global variable values */
   /**
    * Description: Functions for retrieving and setting global variables in V9<br>
    * objects.<br>
    * Arguments:<br>
    *         <br>
    * Comments:<br>
    * <p>
    * ***********************************************************************
    */
   public logical flSetGlobalList(final character _icVarValueList)
   {
      character icVarValueList = TypeFactory.initInput(_icVarValueList);
      
      return function("FlSetGlobalList", logical.class, new Block((Body) () -> 
      {
         /* Set a number of globals. Input parameter is pipe-separated var=value list */
         ControlFlowOps.invokeWithMode("agblsfn2.p", "I", icVarValueList);
      }));
   }

   public logical flSetGlobal(final character _icGlobalVarName, final character _icValue)
   {
      character icGlobalVarName = TypeFactory.initInput(_icGlobalVarName);
      character icValue = TypeFactory.initInput(_icValue);
      
      return function("FlSetGlobal", logical.class, new Block((Body) () -> 
      {
         /* Set a single global variable to a given value */
         returnNormal(flSetGlobalList(new character(substitute("&1=&2", icGlobalVarName, icValue))));
      }));
   }

   public character fcGetGlobal(final character _icGlobalVarName)
   {
      character icGlobalVarName = TypeFactory.initInput(_icGlobalVarName);
      /* Retrieve the value of a 'global' variable as a character */
      character ocValue = TypeFactory.character();
      
      return function("FcGetGlobal", character.class, new Block((Body) () -> 
      {
         ControlFlowOps.invokeWithMode("agblsfn1.p", "IO", icGlobalVarName, ocValue);
         
         if (_isGreaterThan(ControlFlowOps.getReturnValue(), ""))
         {
            messageBox(new Object[]
            {
               "Error evaluating global variable:",
               icGlobalVarName,
               new SkipEntity(true),
               "Error message:",
               ControlFlowOps.getReturnValue()
            }, ALERT_MESSAGE, BTN_OK, (String) null);
            returnNormal("");
         }
         
         returnNormal(ocValue);
      }));
   }

   public integer fiGetGlobal(final character _icGlobalVarName)
   {
      character icGlobalVarName = TypeFactory.initInput(_icGlobalVarName);
      /* Retrieve the value of a 'global' variable as an integer */
      character ocCharValue = TypeFactory.character();
      integer oiIntValue = TypeFactory.integer();
      
      return function("FiGetGlobal", integer.class, new Block((Body) () -> 
      {
         /* Retrieve as char first */
         ocCharValue.assign(fcGetGlobal(icGlobalVarName));
         
         if (_or(isEqual(ocCharValue, ""), () -> isUnknown(ocCharValue)))
         {
            returnNormal(new integer());
         }
         
         ErrorManager.silentErrorEnable();
         /* Convert to int */
         oiIntValue.assign(new integer(ocCharValue));
         ErrorManager.silentErrorDisable();
         
         if (_isUnknown(oiIntValue))
         {
            messageBox(new Object[]
            {
               "Error converting global variable to integer:",
               icGlobalVarName,
               new SkipEntity(true),
               "Character value:",
               ocCharValue
            }, ALERT_MESSAGE, BTN_OK, (String) null);
            returnNormal(new integer());
         }
         
         returnNormal(oiIntValue);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     Starts a super proc for THIS-PROCEDURE, then copies all existing<br>
    *              supers of THIS-PROCEDURE to supers of the newly ran super proc<br>
    *              (if it was newly ran by start-super-proc)
    */
   public void poisstartSuperProc(final character _pcProcName)
   {
      character pcProcName = TypeFactory.initInput(_pcProcName);
      character vcSuperProcsBefore = TypeFactory.character();
      handle vhSuperProc = TypeFactory.handle();
      /* This part copied from smrtprop.i start-super-proc */
      /*DEFINE INPUT PARAMETER pcProcName AS CHARACTER NO-UNDO.*/
      handle hProc = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         blockLabel0:
         {
            /* Debug Include {adbgmsg0.i} */
            if (_isEqual(goisDebug, "YES"))
            {
               if (_and(ghDebugWindowProc.isValid(), () -> isGreaterThan(lookup("PReceiveDebugMessage", ghDebugWindowProc.unwrapProcedure().internalEntries()), 0)))
               {
                  ControlFlowOps.invokeInWithMode("PReceiveDebugMessage", ghDebugWindowProc, "I", concat(EnvironmentOps.getSourceName(1), chr(1), "POISStartSuperProc running", chr(1), "PcProcName = ", (_notUnknown(pcProcName) ? valueOf(pcProcName) : new character("?")), chr(1)));
               }
               else
               {
                  messageBox(new Object[]
                  {
                     EnvironmentOps.getSourceName(new integer(1)),
                     new SkipEntity(1),
                     "POISStartSuperProc running",
                     new SkipEntity(true),
                     "PcProcName",
                     pcProcName,
                     new SkipEntity(true)
                  }, ALERT_INFO, BTN_OK, (String) null);
               }
            }
         }
         
         vcSuperProcsBefore.assign(thisProcedure().unwrapCommonProcedure().superProcedures());
         vhSuperProc.setUnknown();
         hProc.assign(ProcedureManager.firstProcedure());
         
         loopLabel0:
         while (_and(hProc.isValid(), () -> isNotEqual(hProc.unwrapFile().getFileName(), pcProcName)))
         {
            hProc.assign(hProc.unwrap().getNextSibling());
         }
         
         if (_not(hProc.isValid()))
         {
            ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), hProc);
            vhSuperProc.assign(hProc);
         }
         
         /* 9.1 - added SEARCH-TARGET keyword */
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(hProc, ProcedureManager.SEARCH_TARGET);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
         cType.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    *    Purpose:  Clone the current adm property temp-table<br>
    * Parameters: <br>
    *      Notes:  This is used to clone the dynamic property record for static <br>
    *              objects that does not call deleteProperties from destroyObject<br>
    *              in the target-procedure. This way the properties are kept alive <br>
    *              until destroyObject is completed without creating a memory leak,<br>
    *              since this TT is created in the object's widget-pool.
    */
   public void admCloneProps()
   {
      handle hReposBuffer = TypeFactory.handle();
      handle hPropTable = TypeFactory.handle();
      handle hBuffer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hReposBuffer.assign(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))));
         
         if (_and(hReposBuffer.isValid(), () -> isNotEqual(hReposBuffer.unwrap().name(), "ADMProps")))
         {
            ErrorManager.silentErrorEnable();
            hReposBuffer.unwrapBuffer().findFirst(concat("WHERE Target = WIDGET-H(\"", valueOf(thisProcedure()), "\")"));
            ErrorManager.silentErrorDisable();
            
            if ((hReposBuffer.unwrapBuffer().available()).booleanValue())
            {
               TempTableBuilder.create(hPropTable);
               hPropTable.unwrapTempTable().createTableLike(hReposBuffer);
               hPropTable.unwrapTempTable().tempTablePrepare("ADMProps");
               hBuffer.assign(hPropTable.unwrapTempTable().defaultBufferHandle());
               hBuffer.unwrapBuffer().bufferCreate();
               hBuffer.unwrapBuffer().bufferCopy(hReposBuffer);
               /* delete the dynamic's property record */
               /* {fn <func-name> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionIn(logical.class, "deleteProperties", targetProcedure());
               /* ... and save it. This ADM object is now open for business! */
               thisProcedure().unwrapADMData().setADMData(concat(valueOf(hBuffer), chr(1), chr(1)));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Procedure to start a super proc if it's not already running, <br>
    *              and to add it as a super proc in any case.<br>
    * Parameters:  Procedure name to make super.<br>
    * Notes:       NOTE: This presumes that we want only one copy of an ADM<br>
    *              super procedure running per session, meaning that they are <br>
    *              stateless and "multi-threaded". This is intended to be the case<br>
    *              for ours, but may not be true for all super procs.<br>
    *           -  The LAST-SUPER-PROCEDURE-PROP preprocessor allows classes<br>
    *              to specify a property of char or handle that stores<br>
    *              super-procedures that need to be kept at the bottom of the list <br>
    *              (defined by data.i and sbo.i if they are extended by other classes)
    */
   public void startSuperProc(final character _pcProcName)
   {
      character pcProcName = TypeFactory.initInput(_pcProcName);
      handle hProc = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hProc.assign(ProcedureManager.firstProcedure());
         
         loopLabel2:
         while (_and(hProc.isValid(), () -> isNotEqual(hProc.unwrapFile().getFileName(), pcProcName)))
         {
            hProc.assign(hProc.unwrap().getNextSibling());
         }
         
         if (_not(hProc.isValid()))
         {
            ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), hProc);
         }
         
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(hProc, ProcedureManager.SEARCH_TARGET);
         returnNormal();
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Creating the root refreshes the whole tree.<br>
    * <p>
    *              Coding note:<br>
    *              Use Widget:NAME to point to the node id.<br>
    *                  Widget:PRIVATE-DATA used to point to another widget handle
    */
   public void ptreeCreateNodeFrame(final character _icNodeId)
   {
      Ttnode_1_1.Buf ttnodeBuf2 = TemporaryBuffer.define(ttnode, "ttnodeBuf2", "ttNode");
      Ttnode_1_1.Buf childTtnode = TemporaryBuffer.define(ttnode, "childTtnode", "child-ttNode");
      Ttnode_1_1.Buf grandchildTtnode = TemporaryBuffer.define(ttnode, "grandchildTtnode", "grandchild-ttNode");
      character icNodeId = TypeFactory.initInput(_icNodeId);
      handle hFrame = TypeFactory.handle();
      integer iNodeCount = TypeFactory.integer();
      integer iTextIdx = TypeFactory.integer((long) 0);
      /* Zero based */
      handle hImage = TypeFactory.handle();
      handle hLine = TypeFactory.handle();
      handle hHorizontalLine = TypeFactory.handle();
      character cImageName = TypeFactory.character();
      integer iMaxTextWidthPixels = TypeFactory.integer();
      character cWidgetPoolName = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf2);
         /* possibly more efficient as a var */
         cWidgetPoolName.assign(valueOf(thisProcedure()));
         ErrorManager.silentErrorEnable();
         new FindQuery(ttnodeBuf2, "upper(ttnodeBuf2.identifier) = ?", null, "ttnodeBuf2.identifier asc", new Object[]
         {
            toUpperCase(icNodeId)
         }).unique();
         ErrorManager.silentErrorDisable();
         
         AdaptiveQuery query0 = new AdaptiveQuery();
         
         forEach("loopLabel3", new Block((Init) () -> 
         {
            RecordBuffer.openScope(childTtnode);
            query0.initialize(childTtnode, "upper(childTtnode.parentid) = ?", null, "childTtnode.identifier asc", new Object[]
            {
               toUpperCase(icNodeId)
            });
         }, 
         (Body) () -> 
         {
            query0.next();
            iNodeCount.assign(plus(iNodeCount, 1));
            iMaxTextWidthPixels.assign(int64.maximum(iMaxTextWidthPixels, FontTable.getTextWidthPixels(concat(" ", childTtnode.getNodetext(), " "), 10)));
         }));
         
         if (_not(ttnodeBuf2.available()))
         {
            ErrorManager.silentErrorEnable();
            /* <Root> node */
            WidgetPool.delete(cWidgetPoolName);
            ErrorManager.silentErrorDisable();
            lcTreeVirtualRootNodeId.assign(icNodeId);
            
            /* Create nothing if no nodes */
            if (_isEqual(iNodeCount, 0))
            {
               returnNormal();
            }
            
            WidgetPool.create(cWidgetPoolName, true);
            DynamicWidgetFactory.createFrame(hFrame, cWidgetPoolName);
            hFrame.unwrapWidget().setScrollable(new logical(false));
            hFrame.unwrapBox().setBox(new logical(false));
            hFrame.unwrapWidget().setFrameHandle(ftreeviewparentFrame.asWidgetHandle());
            hFrame.unwrapSizeable().setWidthPixels(new integer(plus(iMaxTextWidthPixels, 34 /* FRAME fTreeViewParent:WIDTH-PIXELS - 6 */)));
            hFrame.unwrapSizeable().setHeightPixels(new integer(multiply(iNodeCount, 18)));
            /* Y = -1 * iNodeCount * {&TextSpacingPixels} _* Create the new child frame "hidden" until the parent frame has been resized - to prevent flashing *_ */
            hFrame.unwrapWidget().setHidden(new logical(true /* Trying to prevent flashing */));
            hFrame.unwrapWidget().setFont(new integer(10));
            hFrame.unwrap().name(new character("<ROOT>"));
            registerTriggerPersistentIn(new EventList("CURSOR-DOWN", hFrame, true), "PTrigger_CursorDown", thisProcedure());
            registerTriggerPersistentIn(new EventList("CURSOR-UP", hFrame, true), "PTrigger_CursorUp", thisProcedure());
            /* Create a dummy button to receive focus when tabbing into the treeview, and from which the cursor up, cursor down and return keys will work */
            DynamicWidgetFactory.createButton(lhTreeFocusPixelButton, cWidgetPoolName);
            lhTreeFocusPixelButton.unwrapWidget().setFrameHandle(ftreeviewparentFrame.asWidgetHandle());
            lhTreeFocusPixelButton.unwrapXY().setX(new integer(0));
            lhTreeFocusPixelButton.unwrapXY().setY(new integer(0));
            lhTreeFocusPixelButton.unwrapSizeable().setWidthPixels(new integer(1));
            lhTreeFocusPixelButton.unwrapSizeable().setHeightPixels(new integer(1));
            lhTreeFocusPixelButton.unwrapSensitive().setSensitive(new logical(true));
            lhTreeFocusPixelButton.unwrapWidget().setHidden(new logical(false));
            registerTriggerPersistentIn(new EventList("CHOOSE", lhTreeFocusPixelButton), "PTrigger_Return", thisProcedure());
            registerTriggerPersistentIn(new EventList("CURSOR-DOWN", lhTreeFocusPixelButton), "PTrigger_CursorDown", thisProcedure());
            registerTriggerPersistentIn(new EventList("CURSOR-UP", lhTreeFocusPixelButton), "PTrigger_CursorUp", thisProcedure());
            /* LhTreeFocusPixelButton:MOVE-AFTER-TAB-ITEM(FRAME {&fTreeViewParent}:HANDLE). - required for static position button */
            /* Create another dummy button to swap the focus between - used in trick to move frame when
                     using cursors to move out of frame view */
            DynamicWidgetFactory.createButton(lhTreeFocusSwapPixelButton, cWidgetPoolName);
            lhTreeFocusSwapPixelButton.unwrapWidget().setFrameHandle(ftreeviewparentFrame.asWidget().getFrameHandle());
            lhTreeFocusSwapPixelButton.unwrapXY().setX(ftreeviewparentFrame.getX());
            lhTreeFocusSwapPixelButton.unwrapXY().setY(ftreeviewparentFrame.getY());
            lhTreeFocusSwapPixelButton.unwrapSizeable().setWidthPixels(new integer(1));
            lhTreeFocusSwapPixelButton.unwrapSizeable().setHeightPixels(new integer(1));
            lhTreeFocusSwapPixelButton.unwrapWidget().setHidden(new logical(false /* Required for refreshes of tree (hidden otherwise, which stops the trick from working) */));
            lhTreeFocusSwapPixelButton.unwrapSensitive().setSensitive(new logical(false));
         }
 /* disabling means it can't be tabbed into. it's only used in trick */         else
         {
            DynamicWidgetFactory.createFrame(hFrame, cWidgetPoolName);
            hFrame.unwrapWidget().setScrollable(new logical(false));
            /* SCROLLABLE = TRUE */
            hFrame.unwrapBox().setBox(new logical(false));
            hFrame.unwrapWidget().setFrameHandle(ttnodeBuf2.getNodetexthandle().unwrapWidget().getFrameHandle());
            hFrame.unwrapSizeable().setWidthPixels(new integer(plus(iMaxTextWidthPixels, 34 /* {&ttNode}.nodeTextHandle:FRAME:WIDTH-PIXELS - ({&LevelOffsetPixels} + 2) _* Not sure why, but need 2 extra pixels now *_ */)));
            hFrame.unwrapSizeable().setHeightPixels(new integer(multiply(iNodeCount, 18)));
            hFrame.unwrapWidget().setFont(new integer(10));
            hFrame.unwrapWidget().setHidden(new logical(true /* Trying to prevent flashing */));
            hFrame.unwrap().name(valueOf(ttnodeBuf2.getIdentifier()));
            registerTriggerPersistentIn(new EventList("CURSOR-DOWN", hFrame, true), "PTrigger_CursorDown", thisProcedure());
            registerTriggerPersistentIn(new EventList("CURSOR-UP", hFrame, true), "PTrigger_CursorUp", thisProcedure());
            ttnodeBuf2.setNodeframehandle(hFrame);
         }
         /* Background line */
         DynamicWidgetFactory.createImage(hLine, cWidgetPoolName);
         hLine.unwrapWidget().setParentHandle(hFrame.unwrapFrame().backgroundIteration());
         hLine.unwrapXY().setX(new integer(4));
         hLine.unwrapXY().setY((ttnodeBuf2._available() ? new integer(0) : new integer(6)));
         hLine.unwrapSizeable().setHeightPixels(new integer(plus(plus(multiply(18, minus(iNodeCount, 1)), (ttnodeBuf2._available() ? new integer(6) : new integer(0))), 4)));
         hLine.unwrapImageSupport().loadImage("graphics/treeview/dottedVerticalLine.png");
         
         AdaptiveQuery query1 = new AdaptiveQuery();
         
         forEach("loopLabel4", new Block((Init) () -> 
         {
            RecordBuffer.openScope(childTtnode, grandchildTtnode);
            query1.initialize(childTtnode, "upper(childTtnode.parentid) = ?", null, "childTtnode.identifier asc", new Object[]
            {
               toUpperCase(icNodeId)
            });
         }, 
         (Body) () -> 
         {
            query1.next();
            DynamicWidgetFactory.createText(new HandleFieldRef(childTtnode, "nodetexthandle"), cWidgetPoolName);
            childTtnode.getNodetexthandle().unwrapCommonField().setFormat(new character("x(256)"));
            childTtnode.getNodetexthandle().unwrapWidget().setScreenValue(concat(" ", trim(childTtnode.getNodetext()), " "));
            childTtnode.getNodetexthandle().unwrapWidget().setFrameHandle(hFrame);
            childTtnode.getNodetexthandle().unwrapXY().setX(new integer(34));
            childTtnode.getNodetexthandle().unwrapXY().setY(new integer(plus(multiply(iTextIdx, 18), 1)));
            childTtnode.getNodetexthandle().unwrapSensitive().setSensitive(new logical(true));
            childTtnode.getNodetexthandle().unwrapSizeable().setWidthPixels(FontTable.getTextWidthPixels(concat(" ", trim(childTtnode.getNodetext()), " "), hFrame.unwrapWidget().getFont()));
            childTtnode.getNodetexthandle().unwrap().name(valueOf(childTtnode.getIdentifier()));
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DOWN", childTtnode.getNodetexthandle()), "PTrigger_TextDown", thisProcedure());
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DBLCLICK", childTtnode.getNodetexthandle()), "PTrigger_TextDblClick", thisProcedure());
            DynamicWidgetFactory.createImage(hImage, cWidgetPoolName);
            hImage.unwrapWidget().setFrameHandle(hFrame);
            hImage.unwrapXY().setX(new integer(17));
            hImage.unwrapXY().setY(new integer(plus(multiply(iTextIdx, 18), 2)));
            hImage.unwrapSensitive().setSensitive(new logical(true));
            hImage.unwrap().setPrivateData(valueOf(childTtnode.getNodetexthandle()));
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DBLCLICK", hImage), "PTrigger_ImageDblClick", thisProcedure());
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DOWN", hImage), "PTrigger_ImageDown", thisProcedure());
            cImageName.setUnknown();
            ErrorManager.silentErrorEnable();
            cImageName.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "FcNodeImageName", thisProcedure(), "B", childTtnode));
            ErrorManager.silentErrorDisable();
            
            if (_isUnknown(cImageName))
            {
               if ((new FindQuery(grandchildTtnode, "upper(grandchildTtnode.parentid) = ?", null, "grandchildTtnode.identifier asc", new Object[]
               {
                  (P2JQuery.Parameter) () -> toUpperCase(childTtnode.getIdentifier())
               }, LockType.NONE).hasAny()).booleanValue())
               {
                  cImageName.assign("folder");
               }
               else
               {
                  cImageName.assign("doc");
               }
            }
            else
            {
               cImageName.assign(toLowerCase(cImageName));
            }
            hImage.unwrapImageSupport().loadImage(concat("graphics/treeview/", cImageName, ".png"));
            
            if ((new FindQuery(grandchildTtnode, "upper(grandchildTtnode.parentid) = ?", null, "grandchildTtnode.identifier asc", new Object[]
            {
               (P2JQuery.Parameter) () -> toUpperCase(childTtnode.getIdentifier())
            }, LockType.NONE).hasAny()).booleanValue())
            {
               DynamicWidgetFactory.createImage(new HandleFieldRef(childTtnode, "nodeopenerimagehandle"), cWidgetPoolName);
               childTtnode.getNodeopenerimagehandle().unwrapWidget().setFrameHandle(hFrame);
               childTtnode.getNodeopenerimagehandle().unwrapXY().setX(new integer(0));
               childTtnode.getNodeopenerimagehandle().unwrapXY().setY(new integer(plus(multiply(iTextIdx, 18), 5)));
               childTtnode.getNodeopenerimagehandle().unwrapSensitive().setSensitive(new logical(true));
               childTtnode.getNodeopenerimagehandle().unwrap().name(valueOf(childTtnode.getIdentifier()));
               registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DBLCLICK", childTtnode.getNodeopenerimagehandle()), "PTrigger_OpenerClick", thisProcedure());
               registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DOWN", childTtnode.getNodeopenerimagehandle()), "PTrigger_OpenerClick", thisProcedure());
               childTtnode.getNodeopenerimagehandle().unwrapImageSupport().loadImage("graphics/treeview/plus.png");
            }
            else
            {
               DynamicWidgetFactory.createImage(hHorizontalLine, cWidgetPoolName);
               hHorizontalLine.unwrapWidget().setFrameHandle(hFrame);
               hHorizontalLine.unwrapXY().setX(new integer(3));
               hHorizontalLine.unwrapXY().setY(new integer(plus(multiply(iTextIdx, 18), 10)));
               hHorizontalLine.unwrapSensitive().setSensitive(new logical(true));
               hHorizontalLine.unwrapImageSupport().loadImage("graphics/treeview/dottedHorizontalLine.png");
            }
            
            iTextIdx.assign(plus(iTextIdx, 1));
         }));
         
         if (ttnodeBuf2._available())
         {
            ControlFlowOps.invokeWithMode("PTreeResizeFrame", "IIII", hFrame.unwrapWidget().getFrameHandle(), ttnodeBuf2.getNodetexthandle(), ttnodeBuf2.getNodeframehandle().unwrapSizeable().getHeightPixels(), ttnodeBuf2.getNodeframehandle().unwrapSizeable().getWidthPixels());
            hFrame.unwrapXY().setX(new integer(20));
            hFrame.unwrapXY().setY(new integer(plus(ttnodeBuf2.getNodetexthandle().unwrapXY().getY(), minus(18, 1))));
            /* Frames just don't seem to overlay on another */
            hFrame.unwrapWidget().setVisible(new logical(true));
            hFrame.unwrapSensitive().setSensitive(new logical(true));
         }
         else
         {
            ftreeviewparentFrame.setHeightPixels(ftreeviewparentFrame.getHeightPixels());
            ftreeviewparentFrame.setWidthPixels(ftreeviewparentFrame.getWidthPixels());
            ftreeviewparentFrame.asWidget().setVirtHeightPixels(new integer(int64.maximum(ftreeviewparentFrame.getHeightPixels(), plus(hFrame.unwrapSizeable().getHeightPixels(), 2))));
            ftreeviewparentFrame.asWidget().setVirtWidthPixels(new integer(int64.maximum(ftreeviewparentFrame.getWidthPixels(), plus(hFrame.unwrapSizeable().getWidthPixels(), 7))));
            hFrame.unwrapXY().setX(new integer(4));
            hFrame.unwrapXY().setY(new integer(0));
            hFrame.unwrapWidget().setVisible(new logical(true));
            hFrame.unwrapSensitive().setSensitive(new logical(true));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Ensure that a specific parent node has been expanded.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeExpandNode(final character _icNodeId)
   {
      Ttnode_1_1.Buf ttnodeBuf3 = TemporaryBuffer.define(ttnode, "ttnodeBuf3", "ttNode");
      character icNodeId = TypeFactory.initInput(_icNodeId);
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf3);
         new FindQuery(ttnodeBuf3, "upper(ttnodeBuf3.identifier) = ?", null, "ttnodeBuf3.identifier asc", new Object[]
         {
            toUpperCase(icNodeId)
         }, LockType.NONE).unique();
         
         /* Is the node frame already visible - then leave */
         if (_and(ttnodeBuf3.getNodeframehandle().isValid(), () -> ttnodeBuf3.getNodeframehandle().unwrapWidget().isVisible()))
         {
            returnNormal();
         }
         else
         {
            if (_or(not(ttnodeBuf3.getNodetexthandle().isValid()), () -> not(ttnodeBuf3.getNodetexthandle().unwrapWidget().isVisible())))
            {
               ControlFlowOps.invokeWithMode("PTreeExpandNode", "I", ttnodeBuf3.getParentid());
            }
            
            /* Recurse up */
            ControlFlowOps.invokeWithMode("PTreeToggleNode", "B", ttnodeBuf3);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Keep the focus button next to the widget being used -<br>
    *              this prevents strange issues when tabbing onto the treeview,<br>
    *              when opening/closing branches when the selected row goes off the screen<br>
    *              or when using the scrollbar (if it appears).<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeMoveFocusPixelButton(final handle _ihWidget)
   {
      handle ihWidget = TypeFactory.initInput(_ihWidget);
      integer iY = TypeFactory.integer();
      handle hWidget = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Calculate the Y value of the widget with respect to the container frame */
         hWidget.assign(ihWidget);
         
         loopLabel5:
         while (_isNotEqual(hWidget, ftreeviewparentFrame.asWidgetHandle()))
         {
            iY.assign(plus(iY, hWidget.unwrapXY().getY()));
            hWidget.assign(hWidget.unwrapWidget().getFrameHandle());
         }
         
         if (_isGreaterThan(lhTreeFocusPixelButton.unwrapXY().getY(), iY) /* Moving up, position button on the high side */)
         {
            lhTreeFocusPixelButton.unwrapXY().setY(iY);
         }
         else
         {
            lhTreeFocusPixelButton.unwrapXY().setY(new integer(plus(iY, 14)));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  <br>
    * Notes:       Width - we just have to ensure we can still fit the width in<br>
    *               - we just get bigger for now, we would have to check all the child widths to see if we can shrink.
    */
   public void ptreeResizeFrame(final handle _ihFrame, final handle _ihChild, final integer _iResizeHeightPixels, final integer _iChildFrameWidthPixels)
   {
      Ttnode_1_1.Buf ttnodeBuf4 = TemporaryBuffer.define(ttnode, "ttnodeBuf4", "ttNode");
      handle ihFrame = TypeFactory.initInput(_ihFrame);
      handle ihChild = TypeFactory.initInput(_ihChild);
      integer iResizeHeightPixels = TypeFactory.initInput(_iResizeHeightPixels);
      integer iChildFrameWidthPixels = TypeFactory.initInput(_iChildFrameWidthPixels);
      handle hWidget = TypeFactory.handle();
      logical lLineResized = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Special case is the Container fTreeViewParent frame.
                This has 2 children:
                   The <root> frame which parents all other frames
                   The focus pixel button.
                   
                We assume that the focus pixel button has already been moved in triggers to a position where it can't be forced off the container frame.
                Therefore the only thing we need to do for fTreeViewParent is ensure that the virual height is set correctly
             */
         if (_isEqual(ihFrame, ftreeviewparentFrame.asWidgetHandle()) /* Container frame */)
         {
            if (_isGreaterThan(iResizeHeightPixels, 0) /* Growing */)
            {
               ihFrame.unwrapWidget().setVirtHeightPixels(new integer(int64.maximum(ihFrame.unwrapSizeable().getHeightPixels(), plus(plus(ihChild.unwrapSizeable().getHeightPixels(), iResizeHeightPixels), 7))));
               ihFrame.unwrapWidget().setVirtWidthPixels(new integer(int64.maximum(ihFrame.unwrapSizeable().getWidthPixels(), plus(plus(iChildFrameWidthPixels, 20), 2))));
            }
            else
            {
               ihFrame.unwrapWidget().setVirtHeightPixels(new integer(int64.maximum(ihFrame.unwrapSizeable().getHeightPixels(), plus(ihChild.unwrapSizeable().getHeightPixels(), 7))));
            }
         }
         else
         {
            /* Not container frame - i.e. all other frames */
            if (_isGreaterThan(iResizeHeightPixels, 0))
            {
               /* Getting bigger - Resize parents first */
               ControlFlowOps.invokeWithMode("PTreeResizeFrame", "IIII", ihFrame.unwrapWidget().getFrameHandle(), ihFrame, iResizeHeightPixels, int64.maximum(ihFrame.unwrapSizeable().getWidthPixels(), plus(iChildFrameWidthPixels, 20)));
               ihFrame.unwrapSizeable().setHeightPixels(new integer(plus(ihFrame.unwrapSizeable().getHeightPixels(), iResizeHeightPixels)));
               ihFrame.unwrapSizeable().setWidthPixels(new integer(int64.maximum(ihFrame.unwrapSizeable().getWidthPixels(), plus(iChildFrameWidthPixels, 20))));
            }
            
            /* move everything below the child up or down */
            hWidget.assign(ihFrame.unwrapTree().firstChild());
            /* Field group */
            hWidget.assign(hWidget.unwrapTree().firstChild());
            
            loopLabel6:
            while ((hWidget.isValid()).booleanValue())
            {
               /* + 5 to ignore the openers */
               /* But not the frame */
               /* But not the frame */
               if (_and(isGreaterThan(hWidget.unwrapXY().getY(), plus(ihChild.unwrapXY().getY(), 5)), () /* + 5 to ignore the openers */ -> not(and(isEqual(hWidget.unwrapType().getResourceType(), "FRAME"), () -> isEqual(hWidget.unwrapXY().getY(), plus(ihChild.unwrapXY().getY(), minus(18, 1)))))))
               {
                  hWidget.unwrapXY().setY(new integer(plus(hWidget.unwrapXY().getY(), iResizeHeightPixels)));
                  
                  /* Resize line if necessary */
                  if (_not(lLineResized))
                  {
                     if ((ihFrame.unwrapFrame().backgroundIteration().unwrapTree().firstChild().isValid()).booleanValue())
                     {
                        ihFrame.unwrapFrame().backgroundIteration().unwrapTree().firstChild().unwrapSizeable().setHeightPixels(new integer(plus(ihFrame.unwrapFrame().backgroundIteration().unwrapTree().firstChild().unwrapSizeable().getHeightPixels(), iResizeHeightPixels)));
                        ihFrame.unwrapFrame().backgroundIteration().unwrapTree().firstChild().unwrapImageSupport().loadImage("graphics/treeview/dottedVerticalLine.png");
                     }
                     
                     lLineResized.assign(true);
                  }
               }
               hWidget.assign(hWidget.unwrap().getNextSibling());
            }
            
            if (_isLessThan(iResizeHeightPixels, 0))
            {
               /* Getting Smaller - children have been resized first, so next shrink this frame's height and then its parent's */
               ihFrame.unwrapSizeable().setHeightPixels(new integer(plus(ihFrame.unwrapSizeable().getHeightPixels(), iResizeHeightPixels)));
               ControlFlowOps.invokeWithMode("PTreeResizeFrame", "IIII", ihFrame.unwrapWidget().getFrameHandle(), ihFrame, iResizeHeightPixels, int64.maximum(ihFrame.unwrapSizeable().getWidthPixels(), plus(iChildFrameWidthPixels, 20)));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeSelectNextNode(final logical _ilForwards)
   {
      Ttnode_1_1.Buf ttnodeBuf5 = TemporaryBuffer.define(ttnode, "ttnodeBuf5", "ttNode");
      logical ilForwards = TypeFactory.initInput(_ilForwards);
      character cNodeId = TypeFactory.character();
      character cNextNodeId = TypeFactory.character(null);
      character cParentNodeId = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf5);
         
         if (_not(lhTreeSelectedText.isValid()))
         {
            ErrorManager.silentErrorEnable();
            new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.parentid) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
            {
               toUpperCase(lcTreeVirtualRootNodeId)
            }).first();
            ErrorManager.silentErrorDisable();
            
            if (ttnodeBuf5._available())
            {
               ControlFlowOps.invokeWithMode("PTreeSelectNode", "I", ttnodeBuf5.getIdentifier());
            }
         }
         else
         {
            cNodeId.assign((lhTreeSelectedText.unwrap().name()));
            
            if ((ilForwards).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               /* Do we have any children visible? */
               new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.parentid) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
               {
                  toUpperCase(cNodeId)
               }).first();
               ErrorManager.silentErrorDisable();
               
               if (_and(and(ttnodeBuf5.available(), () -> ttnodeBuf5.getNodetexthandle().isValid()), () -> ttnodeBuf5.getNodetexthandle().unwrapWidget().isVisible()))
               {
                  cNextNodeId.assign(ttnodeBuf5.getIdentifier());
               }
               else
               {
                  LogicalOp whileClause0 = () -> isNotEqual(cNodeId, lcTreeVirtualRootNodeId);
                  
                  repeatWhile("loopLabel7", whileClause0, new Block((Body) () -> 
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.identifier) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
                     {
                        toUpperCase(cNodeId)
                     }).unique();
                     ErrorManager.silentErrorDisable();
                     cParentNodeId.assign(ttnodeBuf5.getParentid());
                     ErrorManager.silentErrorEnable();
                     new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.parentid) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
                     {
                        toUpperCase(cParentNodeId)
                     }).next();
                     ErrorManager.silentErrorDisable();
                     
                     if (ttnodeBuf5._available())
                     {
                        cNextNodeId.assign(ttnodeBuf5.getIdentifier());
                        leave("loopLabel7");
                     }
                     else
                     {
                        cNodeId.assign(cParentNodeId);
                     }
                  }));
               }
            }
            else
            {
               ErrorManager.silentErrorEnable();
               /* Backwards */
               /* Do I have a previous sibling? */
               new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.identifier) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
               {
                  toUpperCase(cNodeId)
               }).unique();
               ErrorManager.silentErrorDisable();
               cParentNodeId.assign(ttnodeBuf5.getParentid());
               ErrorManager.silentErrorEnable();
               new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.parentid) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
               {
                  toUpperCase(cParentNodeId)
               }).previous();
               ErrorManager.silentErrorDisable();
               
               /* If so, what's its last visible child (or itself)? */
               if (ttnodeBuf5._available())
               {
                  cNodeId.assign(ttnodeBuf5.getIdentifier());
                  
                  repeat("loopLabel8", new Block((Body) () -> 
                  {
                     ErrorManager.silentErrorEnable();
                     new FindQuery(ttnodeBuf5, "upper(ttnodeBuf5.parentid) = ?", null, "ttnodeBuf5.identifier asc", new Object[]
                     {
                        toUpperCase(cNodeId)
                     }).last();
                     ErrorManager.silentErrorDisable();
                     
                     if (_and(and(ttnodeBuf5.available(), () -> ttnodeBuf5.getNodetexthandle().isValid()), () -> ttnodeBuf5.getNodetexthandle().unwrapWidget().isVisible()))
                     {
                        cNodeId.assign(ttnodeBuf5.getIdentifier());
                     }
                     else
                     {
                        leave("loopLabel8");
                     }
                  }));
                  
                  cNextNodeId.assign(cNodeId);
               }
               else
               {
                  if (_isNotEqual(cParentNodeId, lcTreeVirtualRootNodeId))
                  {
                     cNextNodeId.assign(cParentNodeId);
                  }
               }
            }
            
            if (_notUnknown(cNextNodeId))
            {
               ControlFlowOps.invokeWithMode("PTreeSelectNode", "I", cNextNodeId);
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeSelectNode(final character _icNodeId)
   {
      Ttnode_1_1.Buf ttnodeBuf6 = TemporaryBuffer.define(ttnode, "ttnodeBuf6", "ttNode");
      character icNodeId = TypeFactory.initInput(_icNodeId);
      handle hOriginalFocus = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf6);
         ErrorManager.silentErrorEnable();
         /* For focus trick */
         /* If node isn't present or visible, then select parent node */
         new FindQuery(ttnodeBuf6, "upper(ttnodeBuf6.identifier) = ?", null, "ttnodeBuf6.identifier asc", new Object[]
         {
            toUpperCase(icNodeId)
         }).unique();
         ErrorManager.silentErrorDisable();
         
         if (_not(ttnodeBuf6.available()))
         {
            returnNormal();
         }
         
         if (_or(not(ttnodeBuf6.getNodetexthandle().isValid()), () -> not(ttnodeBuf6.getNodetexthandle().unwrapWidget().isVisible())))
         {
            ControlFlowOps.invokeWithMode("PTreeExpandNode", "I", ttnodeBuf6.getParentid());
         }
         
         /* By thie time, the nodeTextHandle should be valid, regardless! */
         if (_isNotEqual(lhTreeSelectedText, ttnodeBuf6.getNodetexthandle()))
         {
            if ((lhTreeSelectedText.isValid()).booleanValue())
            {
               lhTreeSelectedText.unwrapWidget().setBgColor(new integer());
               lhTreeSelectedText.unwrapWidget().setFgColor(new integer());
            }
            
            lhTreeSelectedText.assign(ttnodeBuf6.getNodetexthandle());
            lhTreeSelectedText.unwrapWidget().setBgColor(new integer(1));
            lhTreeSelectedText.unwrapWidget().setFgColor(new integer(15));
            ControlFlowOps.invokeWithMode("PTreeMoveFocusPixelButton", "I", lhTreeSelectedText);
            
            /* Trick to force the selected text into view (if it isn't already) - by swapping the focus out and into the focus pixel button */
            /* NB, can't find a Progress way of identifying where a frame is scrolled to, nor manipulating the scrolled frame, but this trick works */
            if ((lhTreeFocusSwapPixelButton.unwrapWidget().isVisible()).booleanValue())
            {
               hOriginalFocus.assign(focus());
               lhTreeFocusSwapPixelButton.unwrapSensitive().setSensitive(new logical(true));
               apply(lhTreeFocusSwapPixelButton, "ENTRY");
               lhTreeFocusSwapPixelButton.unwrapSensitive().setSensitive(new logical(false));
               ftreeviewparentFrame.apply("ENTRY");
               apply(hOriginalFocus, "ENTRY");
            }
            
            ErrorManager.silentErrorEnable();
            ControlFlowOps.invokeInWithMode("PNodeSelected", thisProcedure(), "I", icNodeId);
            ErrorManager.silentErrorDisable();
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeToggleNode(final Ttnode_1_1.Buf ttnodeBuf7)
   {
      Ttnode_1_1.Buf childTtnodeBuf2 = TemporaryBuffer.define(ttnode, "childTtnodeBuf2", "child-ttNode");
      
      internalProcedure(new Block((Init) () -> 
      {
         Ftreefr0.this.ttnodeBuf7 = RecordBuffer.defineAlias(Ttnode_1_1.Buf.class, ttnodeBuf7, "ttnodeBuf7", "ttNode");
      }, 
      (Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf7, childTtnodeBuf2);
         /* Move dummy button to toggling node, at start */
         ControlFlowOps.invokeWithMode("PTreeMoveFocusPixelButton", "I", ttnodeBuf7.getNodetexthandle());
         
         if ((ttnodeBuf7.getNodeframehandle().isValid()).booleanValue())
         {
            if ((ttnodeBuf7.getNodeframehandle().unwrapWidget().isVisible()).booleanValue())
            {
               /* Hide and shrink */
               ttnodeBuf7.getNodeframehandle().unwrapWidget().setHidden(new logical(true));
               ttnodeBuf7.getNodeframehandle().unwrapXY().setY(new integer(minus(-1, ttnodeBuf7.getNodeframehandle().unwrapSizeable().getHeightPixels())));
               
               /* Hide it away */
               if ((ttnodeBuf7.getNodeopenerimagehandle().isValid()).booleanValue())
               {
                  ttnodeBuf7.getNodeopenerimagehandle().unwrapImageSupport().loadImage("graphics/treeview/plus.png");
               }
               
               ControlFlowOps.invokeWithMode("PTreeResizeFrame", "IIII", ttnodeBuf7.getNodetexthandle().unwrapWidget().getFrameHandle(), ttnodeBuf7.getNodetexthandle(), multiply(-1, ttnodeBuf7.getNodeframehandle().unwrapWidget().getVirtHeightPixels()), ttnodeBuf7.getNodeframehandle().unwrapSizeable().getWidthPixels());
            }
            else
            {
               /* Grow and view */
               ControlFlowOps.invokeWithMode("PTreeResizeFrame", "IIII", ttnodeBuf7.getNodetexthandle().unwrapWidget().getFrameHandle(), ttnodeBuf7.getNodetexthandle(), ttnodeBuf7.getNodeframehandle().unwrapWidget().getVirtHeightPixels(), ttnodeBuf7.getNodeframehandle().unwrapSizeable().getWidthPixels());
               ttnodeBuf7.getNodeframehandle().unwrapXY().setY(new integer(plus(ttnodeBuf7.getNodetexthandle().unwrapXY().getY(), minus(18, 2))));
               /* Move back from whence it came */
               ttnodeBuf7.getNodeframehandle().unwrapWidget().setVisible(new logical(true));
               
               if ((ttnodeBuf7.getNodeopenerimagehandle().isValid()).booleanValue())
               {
                  ttnodeBuf7.getNodeopenerimagehandle().unwrapImageSupport().loadImage("graphics/treeview/minus.png");
               }
            }
         }
         else
         {
            if ((new FindQuery(childTtnodeBuf2, "upper(childTtnodeBuf2.parentid) = ?", null, "childTtnodeBuf2.identifier asc", new Object[]
            {
               (P2JQuery.Parameter) () -> toUpperCase(ttnodeBuf7.getIdentifier())
            }, LockType.NONE).hasAny()).booleanValue())
            {
               ControlFlowOps.invokeWithMode("PTreeCreateNodeFrame", "I", ttnodeBuf7.getIdentifier());
               ttnodeBuf7.getNodeopenerimagehandle().unwrapImageSupport().loadImage("graphics/treeview/minus.png");
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerCursorDown()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeWithMode("PTreeSelectNextNode", "I", new logical(true));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerCursorUp()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeWithMode("PTreeSelectNextNode", "I", new logical(false));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Have to use intermediatory hTextHandle var because Progress is sh!te
    */
   public void ptriggerImageDblClick()
   {
      handle hTextHandle = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hTextHandle.assign(handle.fromString(self().unwrap().getPrivateData()));
         apply(hTextHandle, "MOUSE-SELECT-DBLCLICK");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Have to use intermediatory hTextHandle var because Progress is sh!te
    */
   public void ptriggerImageDown()
   {
      handle hTextHandle = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hTextHandle.assign(handle.fromString(self().unwrap().getPrivateData()));
         apply(hTextHandle, "MOUSE-SELECT-DOWN");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerOpenerClick()
   {
      Ttnode_1_1.Buf ttnodeBuf8 = TemporaryBuffer.define(ttnode, "ttnodeBuf8", "ttNode");
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf8);
         new FindQuery(ttnodeBuf8, "upper(ttnodeBuf8.identifier) = ?", null, "ttnodeBuf8.identifier asc", new Object[]
         {
            toUpperCase(self().unwrap().name())
         }).unique();
         ControlFlowOps.invokeWithMode("PTreeToggleNode", "B", ttnodeBuf8);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerReturn()
   {
      internalProcedure(new Block((Body) () -> 
      {
         if ((lhTreeSelectedText.isValid()).booleanValue())
         {
            apply(lhTreeSelectedText, "MOUSE-SELECT-DBLCLICK");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerTextDblClick()
   {
      Ttnode_1_1.Buf ttnodeBuf9 = TemporaryBuffer.define(ttnode, "ttnodeBuf9", "ttNode");
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf9);
         new FindQuery(ttnodeBuf9, "upper(ttnodeBuf9.identifier) = ?", null, "ttnodeBuf9.identifier asc", new Object[]
         {
            toUpperCase(self().unwrap().name())
         }).unique();
         ControlFlowOps.invokeWithMode("PTreeToggleNode", "B", ttnodeBuf9);
         ErrorManager.silentErrorEnable();
         ControlFlowOps.invokeInWithMode("PNodeDblClicked", thisProcedure(), "I", ttnodeBuf9.getIdentifier());
         ErrorManager.silentErrorDisable();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerTextDown()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeWithMode("PTreeSelectNode", "I", self().unwrap().name());
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     Super Override<br>
    * Parameters:  <br>
    * Notes:
    */
   public void applyEntry(final character _pcField)
   {
      character pcField = TypeFactory.initInput(_pcField);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void dataAvailable(final character _pcRelative)
   {
      character pcRelative = TypeFactory.initInput(_pcRelative);
      handle vhDataSource = TypeFactory.handle();
      character vcRowIdent = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Only refresh if the tree has been initialized */
         if (_not(alTreeInitialized))
         {
            returnNormal();
         }
         
         /* {get Prop var [handle]} */ 
         vhDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if (_isEqual(pcRelative, "FIRST"))
         {
            LogicalTerminal.setWaitState("GENERAL");
            ControlFlowOps.invokeWithMode("PBuildTree", "I", isGreaterThan(lcCurrentRowIdent, ""));
            
            /* Reposition pending? */
            if (_isGreaterThan(lcCurrentRowIdent, ""))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "setAcSelectedNode", targetProcedure(), "I", lcCurrentRowIdent);
            }
            
            LogicalTerminal.setWaitState("");
         }
         else
         {
            if (_isEqual(pcRelative, "DIFFERENT"))
            {
               /* {get Prop var [handle]} */
               vcRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getrowIdent", vhDataSource));
               
               if (_notUnknown(vcRowIdent))
               {
                  ErrorManager.silentErrorEnable();
                  new FindQuery(ttnode, "upper(ttnode.rowident) = ?", null, "ttnode.identifier asc", new Object[]
                  {
                     toUpperCase(vcRowIdent)
                  }).unique();
                  ErrorManager.silentErrorDisable();
                  
                  if (ttnode._available())
                  {
                     ControlFlowOps.invokeWithMode("PTreeSelectNode", "I", ttnode.getIdentifier());
                  }
               }
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Run by ADM just after delete has completed<br>
    *              Sets record to reposition to when query is reopened
    */
   public void deleteComplete()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         /* We want to reposition to a node near the one which has been deleted 
              after the query has reopened */
         /* {get Prop var [handle]} */
         lcCurrentRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", sourceProcedure()));
         ErrorManager.silentErrorDisable();
         ErrorManager.silentErrorEnable();
         lcCurrentRowIdent.assign(fcGetRowToPositionAfterDelete());
         ErrorManager.silentErrorDisable();
         ErrorManager.silentErrorEnable();
         /* {set Prop value [handle]} */
         ControlFlowOps.invokeDynamicFunctionInWithMode("setAcRowIdentForReposition", sourceProcedure(), "I", lcCurrentRowIdent);
         ErrorManager.silentErrorDisable();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void disableUi()
   {
      internalProcedure(new Block((Body) () -> 
      {
         if ((thisProcedure().unwrapProcedure().isPersistent()).booleanValue())
         {
            HandleOps.delete(thisProcedure());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void enableUi()
   {
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Expand/Collapse node given its key<br>
    * Notes:       Can pass in yes, no or ? to say whether to expand, collapse or<br>
    *              toggle between expanded/collapsed
    */
   public void expandNode(final character _iCKey_1, final logical _iLogExpanded)
   {
      character iCKey_1 = TypeFactory.initInput(_iCKey_1);
      logical iLogExpanded = TypeFactory.initInput(_iLogExpanded);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void fetchDataSet(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      handle vhDataSource = TypeFactory.handle();
      handle hQuery = TypeFactory.handle();
      integer viList = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* If this is the case we we last on a survey */
         viList.assign(lookup(lcNodeKey, lcIdList));
         
         if (_isNotEqual(viList, 0))
         {
            /* {get Prop var [handle]} */ 
            vhDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if ((vhDataSource.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */
               hQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataHandle", vhDataSource));
               
               if ((hQuery.isValid()).booleanValue())
               {
                  ErrorManager.silentErrorEnable();
                  hQuery.unwrapQuery().queryOpen();
                  ErrorManager.silentErrorDisable();
               }
            }
         }
         else
         {
            if ((lhLevelData.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */
               hQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataHandle", lhLevelData));
               
               if ((hQuery.isValid()).booleanValue())
               {
                  ErrorManager.silentErrorEnable();
                  hQuery.unwrapQuery().queryOpen();
                  ErrorManager.silentErrorDisable();
               }
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void getHitTestNode(final comhandle ochHandle)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(ochHandle);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Code placed here will execute PRIOR to standard behavior.
    */
   public void initializeObject()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
         lCUibmode.assign(ghProp.unwrapBufferField().value());
         /* Check for a data source SDO */
         ControlFlowOps.invoke("PCheckDataSource");
         ControlFlowOps.runSuper("initializeObject");
         ErrorManager.silentErrorEnable();
         NamedEventManager.subscribeAnywhere(thisProcedure(), "PEVENTRemoveNode", "RemoveNode");
         ErrorManager.silentErrorDisable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         lhContainerSource.assign(ghProp.unwrapBufferField().value());
         ControlFlowOps.invokeWithMode("resizeObject", "II", ftreeviewparentFrame.getHeightChars(), ftreeviewparentFrame.getWidthChars());
         
         /* At design time we disable the control. This allows developer to click 
              and select the tree SmartObject to resize it etc */
         if (_isEqual(lCUibmode, "DESIGN"))
         {
         }
         else
         {
            ControlFlowOps.invokeWithMode("PBuildTree", "I", new logical(false));
            /* FALSE = No reposisition pending */
            alTreeInitialized.assign(true);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Build tree from data-source object's query
    */
   public void pbuildTree(final logical _plRepositionPending)
   {
      logical plRepositionPending = TypeFactory.initInput(_plRepositionPending);
      
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("PEVENTTreeBuild", thisProcedure(), "I", new Object[]
         {
            "START"
         });
         /* Build the temp table */
         ControlFlowOps.invoke("PBuildTreeTable");
         
         if (_isGreaterThan(ControlFlowOps.getReturnValue(), ""))
         {
            returnNormal(ControlFlowOps.getReturnValue());
         }
         
         /* Now build the tree */
         ControlFlowOps.invokeWithMode("PTreeCreateNodeFrame", "I", new character(""));
         
         if (_not(plRepositionPending))
         {
            /* Now select first node in tree */
            if ((alAutoSelectRootNodeOnOpen).booleanValue())
            {
               ControlFlowOps.invokeIn("PSelectFirstNode", thisProcedure());
            }
         }
         /* ??? Not required for ftreefr0.w ???
             _* If auto expanding root then do it *_
             IF AcAutoExpandSingleRoot = "YES" THEN
                 chTreeRoot:expanded = yes.
             */
         NamedEventManager.publish("PEVENTTreeBuild", thisProcedure(), "I", new Object[]
         {
            "END"
         });
         returnNormal("");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pbuildTreeTable()
   {
      Ttnode_1_1.Buf ttnodeBuf10 = TemporaryBuffer.define(ttnode, "ttnodeBuf10", "ttNode");
      Ttnode_1_1.Buf xyz = TemporaryBuffer.define(ttnode, "xyz", "xyz");
      handle hColumn = TypeFactory.handle();
      character vcImageName = TypeFactory.character();
      character cId = TypeFactory.character();
      character cText = TypeFactory.character();
      character cparentId = TypeFactory.character();
      character cRowIdent_1 = TypeFactory.character();
      character cLevelActive = TypeFactory.character();
      character cLevelLeaf = TypeFactory.character();
      handle vhLevelQuery = TypeFactory.handle();
      handle vhRowObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf10, xyz);
         ttnodeBuf10.deleteAll();
         /* {get Prop var [handle]} */ 
         lhLevelData.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         /*
                             END.
                             */
         if ((lhLevelData.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */
            vhLevelQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataHandle", lhLevelData));
            
            if ((vhLevelQuery.isValid()).booleanValue())
            {
               if (_not(vhLevelQuery.unwrapQuery().isOpen()))
               {
                  returnNormal("Query not open");
               }
               
               vhRowObject.assign(vhLevelQuery.unwrapQuery().bufferHandle(1));
               
               LogicalOp whileClause1 = () -> vhRowObject.unwrapBuffer().available();
               
               doWhile("loopLabel9", whileClause1, new Block((Body) () -> 
               {
                  hColumn.assign(vhRowObject.unwrapBuffer().bufferField(acIdFieldName));
                  cId.assign(trim(hColumn.unwrapBufferField().stringValue()));
                  hColumn.assign(vhRowObject.unwrapBuffer().bufferField(acTextFieldName));
                  cText.assign(trim(hColumn.unwrapBufferField().stringValue()));
                  hColumn.assign(vhRowObject.unwrapBuffer().bufferField(acparentIdFieldName));
                  cparentId.assign(trim(hColumn.unwrapBufferField().stringValue()));
                  
                  if (_isEqual(cparentId, "?"))
                  {
                     cparentId.assign("");
                  }
                  
                  /*
                                  hColumn = VhRowObject:BUFFER-FIELD(AcLevelLeaf)
                                  cLevelLeaf = hColumn:STRING-VALUE.
                                  */
                  if (_isEqual(cLevelLeaf, "yes"))
                  {
                     vcImageName.assign("LEAF");
                  }
                  else
                  {
                     vcImageName.assign("LEVEL");
                  }
                  
                  /* {get Prop var [handle]} */
                  cRowIdent_1.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", lhLevelData));
                  
                  if (_and(isNotEqual(lcTreeMode, "DEFN"), () -> isEqual(cLevelActive, "no")))
                  {
                     ErrorManager.silentErrorEnable();
                     vhLevelQuery.unwrapQuery().getNext(LockType.NONE);
                     ErrorManager.silentErrorDisable();
                  }
                  else
                  {
                     /* Only build if you have a Parent there */
                     /*
                                         IF  CAN-FIND(FIRST ttNode WHERE ttNode.id = cparentId USE-INDEX id)
                                         THEN DO:
                                         */
                     ttnodeBuf10.create();
                     RecordBuffer.startBatch();
                     ttnodeBuf10.setIdentifier(cId /* this is the level code field */);
                     ttnodeBuf10.setNodetext(cText);
                     ttnodeBuf10.setParentid(cparentId);
                     ttnodeBuf10.setRowident(cRowIdent_1);
                     ttnodeBuf10.setImagename(vcImageName);
                     ttnodeBuf10.setActive(new character("yes"));
                     RecordBuffer.endBatch();
                     ErrorManager.silentErrorEnable();
                     vhLevelQuery.unwrapQuery().getNext(LockType.NONE);
                     ErrorManager.silentErrorDisable();
                  }
               }));
            }
         }
         else
         {
            returnNormal("No data source");
         }
         ErrorManager.silentErrorEnable();
         new FindQuery(xyz, "upper(xyz.identifier) = '1'", null, "xyz.identifier asc").unique();
         ErrorManager.silentErrorDisable();
         returnNormal("");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Check for a data source SDO<br>
    *              If its there, go into 'SDB mode' (SmartDataBrowser)<br>
    *              Also ensure that the SDO will reopen the query after an add<br>
    *              modify and delete
    */
   public void pcheckDataSource()
   {
      handle vhDataSource = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         vhDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getdataSource", targetProcedure()));
         
         if ((vhDataSource.isValid()).booleanValue())
         {
            llSdbmode.assign(true);
            /* Configure dataSource so query is reopened after add,modify and delete */
            ControlFlowOps.invokeWithMode("modifyListProperty", "IIII", vhDataSource, new character("ADD"), new character("AcReopenQueryAfterButtons"), new character("add,modify,addchild"));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Convert the name of an image to it's number (index) in the<br>
    *              imageview OCX
    */
   public void pconvImageNameToNumber(final character _icImageName, final integer oiImageNumber)
   {
      character icImageName = TypeFactory.initInput(_icImageName);
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(oiImageNumber);
      }, 
      (Body) () -> 
      {
         switch (StringHelper.safeTrimTrailing((icImageName).toStringMessage()).toUpperCase())
         {
            case "SURVEY":
               {
                  oiImageNumber.assign(1);
               }
               break;
            case "LEVEL":
               {
                  oiImageNumber.assign(4);
               }
               break;
            case "LEAF":
               {
                  oiImageNumber.assign(7);
               }
               break;
            default:
               {
                  oiImageNumber.assign(1);
               }
               break;
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pnodeSelected(final character _icNodeId)
   {
      character icNodeId = TypeFactory.initInput(_icNodeId);
      
      internalProcedure(new Block((Body) () -> 
      {
         lcLevelCode.assign(icNodeId);
         
         if ((llSdbmode).booleanValue())
         {
            new FindQuery(ttnode, "upper(ttnode.identifier) = ?", null, "ttnode.identifier asc", new Object[]
            {
               toUpperCase(icNodeId)
            }).unique();
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "setAcSelectedNode", targetProcedure(), "I", ttnode.getRowident());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void pselectFirstNode()
   {
      handle hDataSource = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* only try to reposition when in the same set otherwise problems */
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         lcCurrentSet.assign(ControlFlowOps.invokeDynamicFunctionIn("FcCurrentSet", lhContainerSource));
         
         if (_and(isEqual(lcCurrentSet, lcOldSet), () -> isGreaterThan(length(lcNodeKey), 0)))
         {
            new FindQuery(ttnode, "upper(ttnode.rowident) = ?", null, "ttnode.identifier asc", new Object[]
            {
               toUpperCase(lcNodeKey)
            }).unique();
         }
         else
         {
            ErrorManager.silentErrorEnable();
            new FindQuery(ttnode, "upper(ttnode.parentid) = ''", null, "ttnode.identifier asc").first();
            ErrorManager.silentErrorDisable();
         }
         
         /* Select first one */
         if (ttnode._available())
         {
            ControlFlowOps.invokeWithMode("PTreeSelectNode", "I", ttnode.getIdentifier());
            ControlFlowOps.invokeWithMode("PTreeExpandNode", "I", ttnode.getIdentifier());
         }
         
         lcOldSet.assign(lcCurrentSet);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pswapImageForNode(final character _icNodeKey_1, final integer _iiNewImage)
   {
      character icNodeKey_1 = TypeFactory.initInput(_icNodeKey_1);
      integer iiNewImage = TypeFactory.initInput(_iiNewImage);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pswapTextForNode(final character _icNodeKey_1, final character _icNewText)
   {
      character icNodeKey_1 = TypeFactory.initInput(_icNodeKey_1);
      character icNewText = TypeFactory.initInput(_icNewText);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptransactionValid(final logical _lAddedRecord, final logical _lDeletedRecord, final logical _lModifiedRecord)
   {
      logical lAddedRecord = TypeFactory.initInput(_lAddedRecord);
      logical lDeletedRecord = TypeFactory.initInput(_lDeletedRecord);
      logical lModifiedRecord = TypeFactory.initInput(_lModifiedRecord);
      
      internalProcedure(new Block((Body) () -> 
      {
         llTransactionCompleted.assign(true);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     run any published tree collapse procedures<br>
    * Parameters:  handle of selected node<br>
    * Notes:
    */
   public void ptreeCollapse(final comhandle _chNode)
   {
      comhandle chNode = TypeFactory.initInput(_chNode);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeDblClick(final comhandle _chNode)
   {
      comhandle chNode = TypeFactory.initInput(_chNode);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptreeExpand(final comhandle _chNode)
   {
      comhandle chNode = TypeFactory.initInput(_chNode);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void removeNode(final character _icKey)
   {
      character icKey = TypeFactory.initInput(_icKey);
      
      internalProcedure(new Block((Body) () -> 
      {
         /* TODO
           chNode = chTreeView:Nodes:Remove(IcKey) NO-ERROR. 
           */
         messageBox("Refresh screen to update treeview.", ALERT_INFO, BTN_OK, (String) null);
         lcNodeKey.setUnknown();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void resizeObject(final decimal _pHeight, final decimal _pWidth)
   {
      decimal pHeight = TypeFactory.initInput(_pHeight);
      decimal pWidth = TypeFactory.initInput(_pWidth);
      
      internalProcedure(new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ftreeviewparentFrame.setHeightChars(pHeight);
         ftreeviewparentFrame.setWidthChars(pWidth);
         ftreeviewparentFrame.asWidget().setVirtHeightPixels(ftreeviewparentFrame.getHeightPixels());
         ftreeviewparentFrame.asWidget().setVirtWidthPixels(ftreeviewparentFrame.getWidthPixels());
         ErrorManager.silentErrorDisable();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character fcGetRowToPositionAfterDelete()
   {
      return function("FcGetRowToPositionAfterDelete", character.class, new Block());
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fcNodeImageName(final Ttnode_1_1.Buf ttnodeBuf11)
   {
      return function("FcNodeImageName", character.class, new Block((Init) () -> 
      {
         Ftreefr0.this.ttnodeBuf11 = ttnodeBuf11;
      }, 
      (Body) () -> 
      {
         RecordBuffer.openScope(ttnodeBuf11);
         
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         if (_isEqual(ttnodeBuf11.getActive(), "no"))
         {
            returnNormal("inactive");
         }
         else
         {
            returnNormal(ttnodeBuf11.getImagename());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical flIsNodeExpanded(final character _icNodeKey_1)
   {
      character icNodeKey_1 = TypeFactory.initInput(_icNodeKey_1);
      
      return function("FlIsNodeExpanded", logical.class, new Block());
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getAcSelectedItemKey()
   {
      return function("GetAcSelectedItemKey", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         /*------------------------------------------------------------------------------
           Purpose:  Use to get key of currently selected node
             Notes:  {get AcSelectedItemKey variabletoreceivevalue h_treeview}.
         ------------------------------------------------------------------------------*/
         /*
           IF chTreeView:SelectedItem = 0 OR chTreeView:SelectedItem = ? THEN
               RETURN ?.
           RETURN chTreeView:SelectedItem:KEY.   _* Function return value. *_
           */
         new FindQuery(ttnode, "upper(ttnode.identifier) = ?", null, "ttnode.identifier asc", new Object[]
         {
            toUpperCase(lhTreeSelectedText.unwrap().name())
         }).unique();
         ErrorManager.silentErrorDisable();
         
         if (ttnode._available())
         {
            returnNormal(ttnode.getRowident());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getTreeInitialized()
   {
      return function("getTreeInitialized", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(valueOf(alTreeInitialized, "Yes/No"));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public comhandle key2ComHandle(final character _iCKey_1)
   {
      character iCKey_1 = TypeFactory.initInput(_iCKey_1);
      
      return function("Key2ComHandle", comhandle.class, new Block());
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcAutoExpandSingleRoot(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcAutoExpandSingleRoot", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set to True by the Frame the Tree is in, this 
                     will allow a parent node to auotmatically expand 
                     upon build
         ------------------------------------------------------------------------------*/
         acAutoExpandSingleRoot.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcIdFieldName(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcIdFieldName", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acIdFieldName.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcImageListToUse(final character _ic_2)
   {
      character ic_2 = TypeFactory.initInput(_ic_2);
      
      return function("setAcImageListToUse", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Set which imagelist to use
                     NORMAL - normal image list (16x16 with explorer-like folders)
                     EXPRESSIONS - custom size image list with special images for expressions
             Notes:  
         ------------------------------------------------------------------------------*/
         /* TODO 
             
           CASE Ic:
             WHEN "NORMAL"       THEN chTreeView:ImageList   = chImageListNormal.
             OTHERWISE           MESSAGE SUBST("AcImageListToUse called with invalid image list: &1",Ic).
           END CASE.
         */
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcLevelActive(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcLevelActive", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acLevelActive.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle setAcLevelHandle(final handle _i_12)
   {
      handle i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcLevelHandle", handle.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         acLevelHandle.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcLevelLeaf(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcLevelLeaf", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acLevelLeaf.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcparentIdFieldName(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcparentIdFieldName", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acparentIdFieldName.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcSelectedNode(final character _cRowIdent_1)
   {
      character cRowIdent_1 = TypeFactory.initInput(_cRowIdent_1);
      /*------------------------------------------------------------------------------
        Purpose:  Setting this attribute will just fire fetchRowIdent in the data
                  source SDO
      ------------------------------------------------------------------------------*/
      handle hDataSource = TypeFactory.handle();
      
      return function("SetAcSelectedNode", character.class, new Block((Body) () -> 
      {
         /* Has a survey been selected? */
         if (_isNotEqual(lookup(cRowIdent_1, lcIdList), 0) /* LcIdList is built in the tree build, and is a comma separated list of the cRowidents for Surveys */)
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            /* the Container sets a link to the relevant SDO */
            NamedEventManager.publish("PEVENTUpdateLink", thisProcedure(), "II", new Object[]
            {
               hDataSource,
               "Survey"
            });
            
            if ((hDataSource.isValid()).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fetchRowIdent", hDataSource, "II", cRowIdent_1, "RowIdent");
               ErrorManager.silentErrorDisable();
            }
            
            /* repositions to the desired row in the SDO */
            if (_notUnknown(lcNodeKey))
            {
               lcNodeKey.assign(cRowIdent_1);
            }
            
            /* otherwise On Initial build the ques hasn't a handle to 
                       the panel to disable.(Could check for Valid-handle there
                       but MED has locked */
            if (_isGreaterThan(length(lcOldSet), 0))
            {
 /* !!! Bug - OldSet only reset when reopened  */
               NamedEventManager.publish("PEVENTTreeClick", thisProcedure(), "II", new Object[]
               {
                  lcNodeKey,
                  "No"
               });
            }
            
            returnNormal("");
         }
         else
         {
            /* LhLevelData is set Globally in the Build Tree for the level SDO */
            if ((lhLevelData.isValid()).booleanValue())
            {
               NamedEventManager.publish("PEVENTUpdateLink", thisProcedure(), "II", new Object[]
               {
                  lhLevelData,
                  "Level"
               });
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignQuerySelection", lhLevelData, "III", "flevel_code", lcLevelCode, "=");
               
               /* TODO: this causes the data to be reloaded and the tree being rebuilt
                           DYNAMIC-FUNCTION('openQuery':U IN LhLevelData).
                           */
               /* In this Frame it is refreshing the Browse Twice, 
                              so Block it fetching it in this instance */
               if (_isEqual(valueOf(lhContainerSource.unwrapFile().getFileName()), "fdefnfr0.w"))
               {
                  ErrorManager.silentErrorEnable();
                  ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fetchRowIdent", lhLevelData, "II", cRowIdent_1, "RowIdent");
                  ErrorManager.silentErrorDisable();
               }
               
               lcNodeKey.assign(cRowIdent_1);
               /* TODO: leaf is not used
                           VcLeaf = {fnarg FcColValues 'leaf' LhLevelData}.
                           PUBLISH "PEVENTTreeClick"(INPUT LcNodeKey,
                                                     INPUT VcLeaf
                                                     ).
                           */
               NamedEventManager.publish("PEVENTTreeClick", thisProcedure(), "I", new Object[]
               {
                  lcNodeKey
               });
            }
            returnNormal("");
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcSurveyActive(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcSurveyActive", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes: Set by Container Frame 
         ------------------------------------------------------------------------------*/
         acSurveyActive.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcSurveyCode(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcSurveyCode", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acSurveyCode.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcSurveyDesc(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcSurveyDesc", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acSurveyDesc.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcTextFieldName(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcTextFieldName", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  Set by Container Frame
         ------------------------------------------------------------------------------*/
         acTextFieldName.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAcTreeMode(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAcTreeMode", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes: Set by Container Frame 
         ------------------------------------------------------------------------------*/
         lcTreeMode.assign(i_12);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAiImage(final character _val_1)
   {
      character val_1 = TypeFactory.initInput(_val_1);
      
      return function("SetAiImage", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         aiImage.assign(new integer(val_1));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAiLeafImage(final integer _ii_3)
   {
      integer ii_3 = TypeFactory.initInput(_ii_3);
      
      return function("setAiLeafImage", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Set the image number to be used for the image for leaf nodes
         ------------------------------------------------------------------------------*/
         aiLeafImage.assign(ii_3);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAiLeafSelImage(final integer _ii_3)
   {
      integer ii_3 = TypeFactory.initInput(_ii_3);
      
      return function("setAiLeafSelImage", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Set the image number to be used for the selected image for leaf nodes
         ------------------------------------------------------------------------------*/
         aiLeafSelImage.assign(ii_3);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAiSelectedImage(final integer _ii_3)
   {
      integer ii_3 = TypeFactory.initInput(_ii_3);
      
      return function("setAiSelectedImage", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Sets the image index used for the "selected image" of each node
                     This is the image shown for the selected node
             Notes:  
         ------------------------------------------------------------------------------*/
         aiSelectedImage.assign(ii_3);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlAutoExpandAllNodes(final logical _il_5)
   {
      logical il_5 = TypeFactory.initInput(_il_5);
      
      return function("setAlAutoExpandAllNodes", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Set this attr to determine whether the tree will set the expanded
                     property to 'yes' on every new node
             Notes:  
         ------------------------------------------------------------------------------*/
         alAutoExpandAllNodes.assign(il_5);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlAutoSelectRootNodeOnOpen(final logical _il_5)
   {
      logical il_5 = TypeFactory.initInput(_il_5);
      
      return function("setAlAutoSelectRootNodeOnOpen", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  If this is true then root node will be selected when tree opens
         ------------------------------------------------------------------------------*/
         alAutoSelectRootNodeOnOpen.assign(il_5);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlAutoSortAllNodes(final logical _il_5)
   {
      logical il_5 = TypeFactory.initInput(_il_5);
      
      return function("setAlAutoSortAllNodes", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Whether to auto sort each new node added
             Notes:  
         ------------------------------------------------------------------------------*/
         /* TODO
           AlAutoSortAllNodes = Il.
           _* Set the whole treeview's sorted property also. This affects the sorting of nodes
              added as root nodes
           *_
           IF chTreeView > 0 THEN
               chTreeView:Sorted = Il.
           */
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlIncludeUnlinkedRoot(final logical _il_5)
   {
      logical il_5 = TypeFactory.initInput(_il_5);
      
      return function("setAlIncludeUnlinkedRoot", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Determines whether SDB tree includes a root node which is not linked
                     to a record in the SDO
             Notes:  
         ------------------------------------------------------------------------------*/
         alIncludeUnlinkedRoot.assign(il_5);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlIncludeUnlinkedRootText(final character _ic_2)
   {
      character ic_2 = TypeFactory.initInput(_ic_2);
      
      return function("setAlIncludeUnlinkedRootText", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         alIncludeUnlinkedRootText.assign(ic_2);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlSecurityCheck(final logical _il_5)
   {
      logical il_5 = TypeFactory.initInput(_il_5);
      
      return function("setAlSecurityCheck", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         alSecurityCheck.assign(il_5);
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlTreeInitialized(final character _i_12)
   {
      character i_12 = TypeFactory.initInput(_i_12);
      
      return function("SetAlTreeInitialized", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         alTreeInitialized.assign(isEqual(i_12, "YES"));
      }));
   }

   class HandleExpr0
   extends GenericExpression
   {
      public BaseDataType resolve()
      {
         return lhClientFunctionsSuperProcedure;
      }
   }

   class HandleExpr1
   extends GenericExpression
   {
      public BaseDataType resolve()
      {
         return lhClientFunctionsSuperProcedure;
      }
   }

   class HandleExpr2
   extends GenericExpression
   {
      public BaseDataType resolve()
      {
         return lhClientFunctionsSuperProcedure;
      }
   }

   class HandleExpr3
   extends GenericExpression
   {
      public BaseDataType resolve()
      {
         return lhClientFunctionsSuperProcedure;
      }
   }

   class HandleExpr4
   extends GenericExpression
   {
      public BaseDataType resolve()
      {
         return lhClientFunctionsSuperProcedure;
      }
   }

   class HandleExpr5
   extends GenericExpression
   {
      public BaseDataType resolve()
      {
         return lhClientFunctionsSuperProcedure;
      }
   }
}
