package com.goldencode.hotel.dmo._temp;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with a temporary table.
 */
public interface Ttnode_1
extends Temporary
{
   /**
    * Getter: identifier
    * 
    * @return  identifier
    */
   public character getIdentifier();

   /**
    * Setter: identifier
    * 
    * @param   identifier
    *          identifier
    */
   public void setIdentifier(Text identifier);

   /**
    * Getter: parentid
    * 
    * @return  parentid
    */
   public character getParentid();

   /**
    * Setter: parentid
    * 
    * @param   parentid
    *          parentid
    */
   public void setParentid(Text parentid);

   /**
    * Getter: nodetext
    * 
    * @return  nodetext
    */
   public character getNodetext();

   /**
    * Setter: nodetext
    * 
    * @param   nodetext
    *          nodetext
    */
   public void setNodetext(Text nodetext);

   /**
    * Getter: rowident
    * 
    * @return  rowident
    */
   public character getRowident();

   /**
    * Setter: rowident
    * 
    * @param   rowident
    *          rowident
    */
   public void setRowident(Text rowident);

   /**
    * Getter: securitylevel
    * 
    * @return  securitylevel
    */
   public character getSecuritylevel();

   /**
    * Setter: securitylevel
    * 
    * @param   securitylevel
    *          securitylevel
    */
   public void setSecuritylevel(Text securitylevel);

   /**
    * Getter: imagename
    * 
    * @return  imagename
    */
   public character getImagename();

   /**
    * Setter: imagename
    * 
    * @param   imagename
    *          imagename
    */
   public void setImagename(Text imagename);

   /**
    * Getter: active
    * 
    * @return  active
    */
   public character getActive();

   /**
    * Setter: active
    * 
    * @param   active
    *          active
    */
   public void setActive(Text active);

   /**
    * Getter: usercode
    * 
    * @return  usercode
    */
   public character getUsercode();

   /**
    * Setter: usercode
    * 
    * @param   usercode
    *          usercode
    */
   public void setUsercode(Text usercode);

   /**
    * Getter: instanceseqno
    * 
    * @return  instanceseqno
    */
   public integer getInstanceseqno();

   /**
    * Setter: instanceseqno
    * 
    * @param   instanceseqno
    *          instanceseqno
    */
   public void setInstanceseqno(NumberType instanceseqno);

   /**
    * Getter: nodetexthandle
    * 
    * @return  nodetexthandle
    */
   public handle getNodetexthandle();

   /**
    * Setter: nodetexthandle
    * 
    * @param   nodetexthandle
    *          nodetexthandle
    */
   public void setNodetexthandle(handle nodetexthandle);

   /**
    * Getter: nodeopenerimagehandle
    * 
    * @return  nodeopenerimagehandle
    */
   public handle getNodeopenerimagehandle();

   /**
    * Setter: nodeopenerimagehandle
    * 
    * @param   nodeopenerimagehandle
    *          nodeopenerimagehandle
    */
   public void setNodeopenerimagehandle(handle nodeopenerimagehandle);

   /**
    * Getter: nodeframehandle
    * 
    * @return  nodeframehandle
    */
   public handle getNodeframehandle();

   /**
    * Setter: nodeframehandle
    * 
    * @param   nodeframehandle
    *          nodeframehandle
    */
   public void setNodeframehandle(handle nodeframehandle);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Ttnode_1, Buffer
   {
   }
}
