package com.goldencode.hotel.ui;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

public interface AvailRoomsFrameFmain
extends CommonFrame
{
   public static final Class configClass = AvailRoomsFrameFmainDef.class;

   public ButtonWidget widgetEndDatePicker();

   public integer getRoomType();

   public void setRoomType(integer parm);

   public void setRoomType(int parm);

   public void setRoomType(BaseDataType parm);

   public ComboBoxWidget widgetRoomType();

   public BrowseWidget widgetAvailRooms();

   public BrowseColumnWidget widgetAvailRoomsRoomNumColumn();

   public BrowseColumnWidget widgetAvailRoomsDescriptionColumn();

   public BrowseColumnWidget widgetAvailRoomsFloorColumn();

   public date getStartDate();

   public void setStartDate(date parm);

   public void setStartDate(BaseDataType parm);

   public FillInWidget widgetStartDate();

   public date getEndDate();

   public void setEndDate(date parm);

   public void setEndDate(BaseDataType parm);

   public FillInWidget widgetEndDate();

   public ButtonWidget widgetFindRooms();

   public ButtonWidget widgetCheckIn();

   public ButtonWidget widgetStartDatePicker();

   public integer getReservationDays();

   public void setReservationDays(integer parm);

   public void setReservationDays(int parm);

   public void setReservationDays(BaseDataType parm);

   public TextWidget widgetReservationDays();

   public static class AvailRoomsFrameFmainDef
   extends WidgetList
   {
      ButtonWidget endDatePicker = new ButtonWidget();

      ComboBoxWidget roomType = new ComboBoxWidget();

      BrowseWidget availRooms = new BrowseWidget();

      BrowseColumnWidget availRoomsRoomNumColumn = new BrowseColumnWidget();

      BrowseColumnWidget availRoomsDescriptionColumn = new BrowseColumnWidget();

      BrowseColumnWidget availRoomsFloorColumn = new BrowseColumnWidget();

      FillInWidget startDate = new FillInWidget();

      FillInWidget endDate = new FillInWidget();

      ButtonWidget findRooms = new ButtonWidget();

      ButtonWidget checkIn = new ButtonWidget();

      ButtonWidget startDatePicker = new ButtonWidget();

      TextWidget reservationDays = new TextWidget();

      public void setup(CommonFrame frame)
      {
         frame.setDown(1);
         frame.setNoBox(true);
         frame.setKeepTabOrder(true);
         frame.setOverlay(true);
         frame.setSideLabels(true);
         frame.setNoUnderline(true);
         frame.setThreeD(true);
         frame.setColumn(1);
         frame.setRow(1);
         frame.setWidthChars(125.1);
         frame.setHeightChars(15.38);
         endDatePicker.setImageUp("graphics/calendar.bmp");
         endDatePicker.setImageIns("graphics/calendar-disabled.bmp");
         endDatePicker.setNoFocus(true);
         endDatePicker.setWidthChars(6);
         endDatePicker.setHeightChars(1.19);
         endDatePicker.setRow(4.57);
         endDatePicker.setColumn(34.6);
         endDatePicker.setWidgetId(14);
         roomType.setDataType("integer");
         roomType.setRow(1.48);
         roomType.setColumn(17);
         roomType.setAlign(ControlEntity.ALIGN_COLON);
         roomType.setWidgetId(26);
         availRooms.setRow(1.48);
         availRooms.setColumn(48);
         availRooms.setWidgetId(200);
         availRooms.setNoRowMarkers(true);
         availRooms.setSeparators(true);
         availRooms.setWidthChars(75);
         availRooms.setHeightChars(12.38);
         availRooms.setFitLastColumn(true);
         availRooms.addColumn(availRoomsRoomNumColumn);
         availRoomsRoomNumColumn.setDataType("integer");
         availRoomsRoomNumColumn.setFormat(">>>>9");
         availRoomsRoomNumColumn.setWidthChars(15.2);
         availRoomsRoomNumColumn.setLabel("Room Number");
         availRoomsRoomNumColumn.setColumnLabel("Room Number");
         availRooms.addColumn(availRoomsDescriptionColumn);
         availRoomsDescriptionColumn.setDataType("character");
         availRoomsDescriptionColumn.setColumnLabel("Room Type");
         availRoomsDescriptionColumn.setFormat("x(20)");
         availRoomsDescriptionColumn.setWidthChars(36.2);
         availRoomsDescriptionColumn.setLabel("Description");
         availRooms.addColumn(availRoomsFloorColumn);
         availRoomsFloorColumn.setDataType("integer");
         availRoomsFloorColumn.setFormat(">9");
         availRoomsFloorColumn.setLabel("Floor");
         availRoomsFloorColumn.setColumnLabel("Floor");
         startDate.setDataType("date");
         startDate.setRow(3);
         startDate.setColumn(17);
         startDate.setAlign(ControlEntity.ALIGN_COLON);
         startDate.setWidgetId(18);
         endDate.setDataType("date");
         endDate.setRow(4.67);
         endDate.setColumn(17);
         endDate.setAlign(ControlEntity.ALIGN_COLON);
         endDate.setWidgetId(16);
         findRooms.setWidthChars(30);
         findRooms.setHeightChars(1.14);
         findRooms.setRow(7.67);
         findRooms.setColumn(12);
         findRooms.setWidgetId(28);
         checkIn.setWidthChars(15);
         checkIn.setHeightChars(1.14);
         checkIn.setRow(14.33);
         checkIn.setColumn(48);
         checkIn.setWidgetId(30);
         startDatePicker.setImageUp("graphics/calendar.bmp");
         startDatePicker.setImageIns("graphics/calendar-disabled.bmp");
         startDatePicker.setNoFocus(true);
         startDatePicker.setWidthChars(6);
         startDatePicker.setHeightChars(1.19);
         startDatePicker.setRow(2.91);
         startDatePicker.setColumn(34.6);
         startDatePicker.setWidgetId(20);
         reservationDays.setDataType("integer");
         reservationDays.setRow(6.24);
         reservationDays.setColumn(17);
         reservationDays.setAlign(ControlEntity.ALIGN_COLON);
         reservationDays.setWidgetId(24);
         endDatePicker.setLabel("");
         checkIn.setLabel("Check-In...");
         endDate.setFormat("99/99/99");
         endDate.setLabel("Check-out Date");
         endDate.setWidthChars(14);
         endDate.setHeightChars(1);
         reservationDays.setFormat(">>>>>9");
         reservationDays.setLabel("Days");
         reservationDays.explicitViewAs(true);
         reservationDays.setWidthChars(14);
         reservationDays.setHeightChars(.62);
         findRooms.setLabel("Find Available Rooms");
         startDatePicker.setLabel("");
         roomType.setFormat("->,>>>,>>9");
         roomType.setLabel("Room Type");
         roomType.setInitialInnerLines(5);
         roomType.setItems(new ControlSetItem[]
         {
            new ControlSetItem(new character("All rooms"), new integer(0))
         }, true);
         roomType.setHonorFormat(false);
         roomType.setModeDropDownList(true);
         roomType.setWidthChars(26);
         roomType.setHeightChars(1);
         startDate.setFormat("99/99/99");
         startDate.setLabel("Check-in Date");
         startDate.setWidthChars(14);
         startDate.setHeightChars(1);
      }

      {
         addWidget("endDatePicker", "endDatePicker", endDatePicker);
         addWidget("roomType", "roomType", roomType);
         addWidget("availRooms", "availRooms", availRooms);
         addWidget("availRoomsRoomNumColumn", "room-num", availRoomsRoomNumColumn);
         addWidget("availRoomsDescriptionColumn", "description", availRoomsDescriptionColumn);
         addWidget("availRoomsFloorColumn", "floor", availRoomsFloorColumn);
         addWidget("startDate", "startDate", startDate);
         addWidget("endDate", "endDate", endDate);
         addWidget("findRooms", "findRooms", findRooms);
         addWidget("checkIn", "checkIn", checkIn);
         addWidget("startDatePicker", "startDatePicker", startDatePicker);
         addWidget("reservationDays", "reservationDays", reservationDays);
      }
   }
}
