package com.goldencode.hotel.ui;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

public interface GuestsFrameFmain
extends CommonFrame
{
   public static final Class configClass = GuestsFrameFmainDef.class;

   public ButtonWidget widgetReselFilters();

   public integer getFilterRoom();

   public void setFilterRoom(integer parm);

   public void setFilterRoom(int parm);

   public void setFilterRoom(BaseDataType parm);

   public FillInWidget widgetFilterRoom();

   public character getFindGuest();

   public void setFindGuest(character parm);

   public void setFindGuest(String parm);

   public void setFindGuest(BaseDataType parm);

   public FillInWidget widgetFindGuest();

   public ButtonWidget widgetSearchButton();

   public logical isShowPast();

   public void setShowPast(logical parm);

   public void setShowPast(boolean parm);

   public void setShowPast(BaseDataType parm);

   public ToggleBoxWidget widgetShowPast();

   public BrowseWidget widgetStaysBrowse();

   public BrowseColumnWidget widgetStaysBrowseRoomNumColumn();

   public BrowseColumnWidget widgetStaysBrowseExpr28Column();

   public BrowseColumnWidget widgetStaysBrowseNumGuestsColumn();

   public BrowseColumnWidget widgetStaysBrowseStartDateColumn();

   public BrowseColumnWidget widgetStaysBrowseEndDateColumn();

   public BrowseColumnWidget widgetStaysBrowseExpr29Column();

   public BrowseColumnWidget widgetStaysBrowseDescriptionColumn();

   public BrowseColumnWidget widgetStaysBrowsePriceColumn();

   public ButtonWidget widgetCheckIn();

   public ButtonWidget widgetCheckOut();

   public ButtonWidget widgetUpdateStay();

   public ButtonWidget widgetDeleteButton();

   public static class GuestsFrameFmainDef
   extends WidgetList
   {
      ButtonWidget reselFilters = new ButtonWidget();

      FillInWidget filterRoom = new FillInWidget();

      FillInWidget findGuest = new FillInWidget();

      ButtonWidget searchButton = new ButtonWidget();

      ToggleBoxWidget showPast = new ToggleBoxWidget();

      BrowseWidget staysBrowse = new BrowseWidget();

      BrowseColumnWidget staysBrowseRoomNumColumn = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowseExpr28Column = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowseNumGuestsColumn = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowseStartDateColumn = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowseEndDateColumn = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowseExpr29Column = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowseDescriptionColumn = new BrowseColumnWidget();

      BrowseColumnWidget staysBrowsePriceColumn = new BrowseColumnWidget();

      ButtonWidget checkIn = new ButtonWidget();

      ButtonWidget checkOut = new ButtonWidget();

      ButtonWidget updateStay = new ButtonWidget();

      ButtonWidget deleteButton = new ButtonWidget();

      public void setup(CommonFrame frame)
      {
         frame.setDown(1);
         frame.setNoBox(true);
         frame.setKeepTabOrder(true);
         frame.setOverlay(true);
         frame.setSideLabels(true);
         frame.setNoUnderline(true);
         frame.setThreeD(true);
         frame.setColumn(1);
         frame.setRow(1);
         frame.setWidthChars(125.2);
         frame.setHeightChars(15.38);
         frame.setFont(8);
         reselFilters.setNoFocus(true);
         reselFilters.setWidthChars(15);
         reselFilters.setHeightChars(1);
         reselFilters.setRow(1.48);
         reselFilters.setColumn(100.6);
         reselFilters.setWidgetId(18);
         filterRoom.setDataType("integer");
         filterRoom.setRow(1.48);
         filterRoom.setColumn(17.6);
         filterRoom.setAlign(ControlEntity.ALIGN_COLON);
         filterRoom.setWidgetId(20);
         findGuest.setDataType("character");
         findGuest.setRow(1.48);
         findGuest.setColumn(50.6);
         findGuest.setAlign(ControlEntity.ALIGN_COLON);
         findGuest.setWidgetId(16);
         searchButton.setWidthChars(15);
         searchButton.setHeightChars(1);
         searchButton.setRow(1.48);
         searchButton.setColumn(81.6);
         searchButton.setWidgetId(32);
         showPast.setDataType("logical");
         showPast.setRow(2.91);
         showPast.setColumn(7);
         showPast.setWidgetId(22);
         staysBrowse.setRow(4.1);
         staysBrowse.setColumn(4);
         staysBrowse.setWidgetId(200);
         staysBrowse.setNoRowMarkers(true);
         staysBrowse.setSeparators(true);
         staysBrowse.setWidthChars(119);
         staysBrowse.setHeightChars(9.52);
         staysBrowse.setFont(8);
         staysBrowse.setFitLastColumn(true);
         staysBrowse.addColumn(staysBrowseRoomNumColumn);
         staysBrowseRoomNumColumn.setDataType("integer");
         staysBrowseRoomNumColumn.setColumnLabel("Room Num");
         staysBrowseRoomNumColumn.setFormat(">>>>9");
         staysBrowseRoomNumColumn.setWidthChars(11.2);
         staysBrowseRoomNumColumn.setLabel("Room Number");
         staysBrowse.addColumn(staysBrowseExpr28Column);
         staysBrowseExpr28Column.setDataType("character");
         staysBrowseExpr28Column.setColumnLabel("Guest");
         staysBrowseExpr28Column.setFormat("x(40)");
         staysBrowseExpr28Column.setWidthChars(23.2);
         staysBrowseExpr28Column.setLabel("");
         staysBrowse.addColumn(staysBrowseNumGuestsColumn);
         staysBrowseNumGuestsColumn.setDataType("integer");
         staysBrowseNumGuestsColumn.setColumnLabel("Num Guests");
         staysBrowseNumGuestsColumn.setFormat(">9");
         staysBrowseNumGuestsColumn.setWidthChars(12.2);
         staysBrowseNumGuestsColumn.setLabel("Number of Guests");
         staysBrowse.addColumn(staysBrowseStartDateColumn);
         staysBrowseStartDateColumn.setDataType("date");
         staysBrowseStartDateColumn.setColumnLabel("Check-in");
         staysBrowseStartDateColumn.setFormat("99/99/99");
         staysBrowseStartDateColumn.setWidthChars(10.2);
         staysBrowseStartDateColumn.setLabel("Check-in Date");
         staysBrowse.addColumn(staysBrowseEndDateColumn);
         staysBrowseEndDateColumn.setDataType("date");
         staysBrowseEndDateColumn.setColumnLabel("Check-out");
         staysBrowseEndDateColumn.setFormat("99/99/99");
         staysBrowseEndDateColumn.setWidthChars(10.2);
         staysBrowseEndDateColumn.setLabel("Check-out Date");
         staysBrowse.addColumn(staysBrowseExpr29Column);
         staysBrowseExpr29Column.setDataType("integer");
         staysBrowseExpr29Column.setColumnLabel("Days");
         staysBrowseExpr29Column.setLabel("");
         staysBrowse.addColumn(staysBrowseDescriptionColumn);
         staysBrowseDescriptionColumn.setDataType("character");
         staysBrowseDescriptionColumn.setColumnLabel("Room Type");
         staysBrowseDescriptionColumn.setFormat("x(20)");
         staysBrowseDescriptionColumn.setLabel("Description");
         staysBrowse.addColumn(staysBrowsePriceColumn);
         staysBrowsePriceColumn.setDataType("integer");
         staysBrowsePriceColumn.setColumnLabel("Room Price");
         staysBrowsePriceColumn.setFormat("$ >>>,>>>,>>9");
         staysBrowsePriceColumn.setLabel("Price");
         checkIn.setWidthChars(15);
         checkIn.setHeightChars(1.14);
         checkIn.setRow(14.33);
         checkIn.setColumn(4);
         checkIn.setWidgetId(26);
         checkOut.setWidthChars(15);
         checkOut.setHeightChars(1.14);
         checkOut.setRow(14.33);
         checkOut.setColumn(21.6);
         checkOut.setWidgetId(30);
         updateStay.setWidthChars(15);
         updateStay.setHeightChars(1.14);
         updateStay.setRow(14.33);
         updateStay.setColumn(39.2);
         updateStay.setWidgetId(28);
         deleteButton.setWidthChars(15);
         deleteButton.setHeightChars(1.14);
         deleteButton.setRow(14.33);
         deleteButton.setColumn(57);
         deleteButton.setWidgetId(6);
         searchButton.setLabel("Search");
         deleteButton.setLabel("Delete...");
         checkIn.setLabel("Check-In...");
         showPast.setLabel("Show Past Accomodations");
         showPast.setWidthChars(34);
         showPast.setHeightChars(.81);
         checkOut.setLabel("Check-Out...");
         filterRoom.setFormat(">>>>>");
         filterRoom.setLabel("Filter by Room");
         filterRoom.setWidthChars(14);
         filterRoom.setHeightChars(1);
         updateStay.setLabel("Update...");
         reselFilters.setLabel("Reset Filters");
         findGuest.setFormat("X(256)");
         findGuest.setLabel("Filter by Guest");
         findGuest.setWidthChars(25);
         findGuest.setHeightChars(1);
      }

      {
         addWidget("reselFilters", "reselFilters", reselFilters);
         addWidget("filterRoom", "filterRoom", filterRoom);
         addWidget("findGuest", "findGuest", findGuest);
         addWidget("searchButton", "searchButton", searchButton);
         addWidget("showPast", "showPast", showPast);
         addWidget("staysBrowse", "staysBrowse", staysBrowse);
         addWidget("staysBrowseRoomNumColumn", "room-num", staysBrowseRoomNumColumn);
         addWidget("staysBrowseExpr28Column", "", staysBrowseExpr28Column);
         addWidget("staysBrowseNumGuestsColumn", "num-guests", staysBrowseNumGuestsColumn);
         addWidget("staysBrowseStartDateColumn", "start-date", staysBrowseStartDateColumn);
         addWidget("staysBrowseEndDateColumn", "end-date", staysBrowseEndDateColumn);
         addWidget("staysBrowseExpr29Column", "", staysBrowseExpr29Column);
         addWidget("staysBrowseDescriptionColumn", "description", staysBrowseDescriptionColumn);
         addWidget("staysBrowsePriceColumn", "price", staysBrowsePriceColumn);
         addWidget("checkIn", "checkIn", checkIn);
         addWidget("checkOut", "checkOut", checkOut);
         addWidget("updateStay", "updateStay", updateStay);
         addWidget("deleteButton", "deleteButton", deleteButton);
      }
   }
}
