&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS fFrameWin 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrfrm.w - ADM2 SmartFrame Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartFrame
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER FRAME

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME availRooms

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES room room-type

/* Definitions for BROWSE availRooms                                    */
&Scoped-define FIELDS-IN-QUERY-availRooms room.room-num ~
room-type.description room.floor 
&Scoped-define ENABLED-FIELDS-IN-QUERY-availRooms 
&Scoped-define QUERY-STRING-availRooms FOR EACH room NO-LOCK, ~
      EACH room-type OF room NO-LOCK
&Scoped-define OPEN-QUERY-availRooms OPEN QUERY availRooms FOR EACH room NO-LOCK, ~
      EACH room-type OF room NO-LOCK.
&Scoped-define TABLES-IN-QUERY-availRooms room room-type
&Scoped-define FIRST-TABLE-IN-QUERY-availRooms room
&Scoped-define SECOND-TABLE-IN-QUERY-availRooms room-type


/* Definitions for FRAME fMain                                          */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS endDatePicker roomType availRooms startDate ~
endDate findRooms checkIn startDatePicker reservationDays 
&Scoped-Define DISPLAYED-OBJECTS roomType startDate endDate reservationDays 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON checkIn 
     LABEL "Check-In..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON endDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE BUTTON findRooms 
     LABEL "Find Available Rooms" 
     SIZE 30 BY 1.14.

DEFINE BUTTON startDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE VARIABLE roomType AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 
     LABEL "Room Type" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     LIST-ITEM-PAIRS "All rooms",0
     DROP-DOWN-LIST
     SIZE 26 BY 1 NO-UNDO.

DEFINE VARIABLE endDate AS DATE FORMAT "99/99/99":U 
     LABEL "Check-out Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE reservationDays AS INTEGER FORMAT ">>>>>9":U INITIAL 0 
     LABEL "Days" 
      VIEW-AS TEXT 
     SIZE 14 BY .62 NO-UNDO.

DEFINE VARIABLE startDate AS DATE FORMAT "99/99/99":U 
     LABEL "Check-in Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY availRooms FOR 
      room, 
      room-type SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE availRooms
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS availRooms fFrameWin _STRUCTURED
  QUERY availRooms NO-LOCK DISPLAY
      room.room-num FORMAT ">>>>9":U WIDTH 15.2
      room-type.description COLUMN-LABEL "Room Type" FORMAT "x(20)":U
            WIDTH 36.2
      room.floor FORMAT ">9":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 75 BY 12.38 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     endDatePicker AT ROW 4.57 COL 34.6 WIDGET-ID 14
     roomType AT ROW 1.48 COL 17 COLON-ALIGNED WIDGET-ID 26
     availRooms AT ROW 1.48 COL 48 WIDGET-ID 200
     startDate AT ROW 3 COL 17 COLON-ALIGNED WIDGET-ID 18
     endDate AT ROW 4.67 COL 17 COLON-ALIGNED WIDGET-ID 16
     findRooms AT ROW 7.67 COL 12 WIDGET-ID 28
     checkIn AT ROW 14.33 COL 48 WIDGET-ID 30
     startDatePicker AT ROW 2.91 COL 34.6 WIDGET-ID 20
     reservationDays AT ROW 6.24 COL 17 COLON-ALIGNED WIDGET-ID 24
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 125.1 BY 15.38 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartFrame
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: PERSISTENT-ONLY APPSERVER
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW fFrameWin ASSIGN
         HEIGHT             = 15.38
         WIDTH              = 125.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB fFrameWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW fFrameWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
   NOT-VISIBLE FRAME-NAME                                               */
/* BROWSE-TAB availRooms roomType fMain */
ASSIGN 
       FRAME fMain:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE availRooms
/* Query rebuild information for BROWSE availRooms
     _TblList          = "hotel.room,hotel.room-type OF hotel.room"
     _Options          = "NO-LOCK"
     _FldNameList[1]   > hotel.room.room-num
"room.room-num" ? ? "integer" ? ? ? ? ? ? no ? no no "15.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > hotel.room-type.description
"room-type.description" "Room Type" ? "character" ? ? ? ? ? ? no ? no no "36.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   = hotel.room.floor
     _Query            is NOT OPENED
*/  /* BROWSE availRooms */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME fMain
/* Query rebuild information for FRAME fMain
     _Options          = ""
     _Query            is NOT OPENED
*/  /* FRAME fMain */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME checkIn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL checkIn fFrameWin
ON CHOOSE OF checkIn IN FRAME fMain /* Check-In... */
DO:
  IF NOT AVAIL(room) THEN DO:
     {no-selected-records.i "rooms"}
  END.

  DEF VAR date1 AS DATE.
  DEF VAR date2 AS DATE.
  date1 = startDate:INPUT-VALUE IN FRAME fMain.
  date2 = endDate:INPUT-VALUE IN FRAME fMain.
   
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdStayRid AS ROWID.
  DO TRANSACTION:
     RUN update-stay-dialog.w (INPUT rid, 
                               OUTPUT needRefresh, 
                               OUTPUT createdStayRid,
                               INPUT FALSE,
                               room.room-num,
                               date1,
                               date2,
                               ?).

     IF needRefresh THEN DO:
        RUN refresh-avail-rooms.
        publish "refresh-stays".
     END.
     ELSE DO:
        UNDO, LEAVE.
     END.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDate fFrameWin
ON VALUE-CHANGED OF endDate IN FRAME fMain /* Check-out Date */
DO:
   RUN refresh-days.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDatePicker fFrameWin
ON CHOOSE OF endDatePicker IN FRAME fMain
DO:
  {pick-date.i "Check-out Date" endDate fMain}
  RUN refresh-days.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME findRooms
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findRooms fFrameWin
ON CHOOSE OF findRooms IN FRAME fMain /* Find Available Rooms */
DO:
  DEF VAR err AS CHAR.
  RUN check-date(OUTPUT err).
  IF err <> "" THEN DO:
     MESSAGE err VIEW-AS ALERT-BOX ERROR TITLE "Date error".
     RETURN NO-APPLY.
  END.

  RUN refresh-avail-rooms.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME roomType
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL roomType fFrameWin
ON VALUE-CHANGED OF roomType IN FRAME fMain /* Room Type */
DO:
  DEF VAR err AS CHAR.
  RUN check-date(OUTPUT err).
  IF err = "" THEN DO:
     RUN refresh-avail-rooms.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDate fFrameWin
ON VALUE-CHANGED OF startDate IN FRAME fMain /* Check-in Date */
DO:
   RUN refresh-days.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDatePicker fFrameWin
ON CHOOSE OF startDatePicker IN FRAME fMain
DO:
  {pick-date.i "Check-in Date" startDate fMain}
  RUN refresh-days.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME availRooms
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK fFrameWin 


/* ***************************  Main Block  *************************** */

{calc-days.i fMain}

/* Populate Room types */
DEF VAR item-pairs AS CHAR INIT "".
item-pairs = "All rooms,0".
FOR EACH room-type:
  item-pairs = item-pairs  + "," + room-type.DESCRIPTION + "," + STRING(room-type.room-type).
END.
roomType:LIST-ITEM-PAIRS = item-pairs.

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN
   /* Now enable the interface  if in test mode - otherwise this happens when
      the object is explicitly initialized from its container. */
   RUN initializeObject.
&ENDIF

SUBSCRIBE TO "capacityZoom" ANYWHERE.
SUBSCRIBE TO "roomTypePick" ANYWHERE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects fFrameWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check-date fFrameWin 
PROCEDURE check-date :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF OUTPUT PARAMETER err AS CHAR INIT "".

{check-date.i fMain}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI fFrameWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME fMain.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI fFrameWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY roomType startDate endDate reservationDays 
      WITH FRAME fMain.
  ENABLE endDatePicker roomType availRooms startDate endDate findRooms checkIn 
         startDatePicker reservationDays 
      WITH FRAME fMain.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject fFrameWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  RUN check-availability (INPUT TODAY, INPUT TODAY + 7).

  /* Code placed here will execute AFTER standard behavior.    */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE capacityZoom fFrameWin 
PROCEDURE capacityZoom :
/*------------------------------------------------------------------------------
  Purpose:     Set start and end dates in UI and check room availability.
  Parameters:  zoomStart
               Start date of capacity zoom date range. Corresponds with start
               date (check in) for a room availability check.
               zoomEnd
               End date of capacity zoom date range. Corresponds with the day
               before end date (check out) for a room availability check.
  Notes:       This procedure is called from a subscription to the "capacityZoom"
               event. Subscription event parameters are sent as strings, not
               dates; they must be converted to dates before updating the UI and
               performing the availability check.
------------------------------------------------------------------------------*/

DEF INPUT PARAMETER zoomStart AS CHAR.
DEF INPUT PARAMETER zoomEnd AS CHAR.

  roomType = 0.
  DISPLAY roomType WITH FRAME fMain.
  RUN check-availability (INPUT DATE(zoomStart), INPUT (DATE(zoomEnd) + 1)).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE roomTypePick fFrameWin 
PROCEDURE roomTypePick :
/*------------------------------------------------------------------------------
  Purpose:     Set room type and check room availability if start and end date
               parameters match those currently being viewed.
  Parameters:  pickStart
               Start date of range associated with external room type event.
               pickEnd
               End date of range associated with external room type event.
  Notes:       This procedure is called from a subscription to the "roomTypePick"
               event. Subscription event parameters are sent as strings, not
               primitive types; they must be converted to primitive types
               before updating the UI and performing the availability check.
------------------------------------------------------------------------------*/

DEF INPUT PARAMETER roomTypeText AS CHAR.
DEF INPUT PARAMETER pickStart AS CHAR.
DEF INPUT PARAMETER pickEnd AS CHAR.
DEF VAR rt AS INT NO-UNDO.
DEF VAR d1 AS DATE NO-UNDO.
DEF VAR d2 AS DATE NO-UNDO.

  ASSIGN d1 = DATE(pickStart)
         d2 = DATE(pickEnd) + 1.
  IF startDate:INPUT-VALUE IN FRAME fMain = d1 AND
     endDate:INPUT-VALUE IN FRAME fMain = d2 THEN
  DO:
    rt = INT(roomTypeText).
    IF CAN-FIND(room-type WHERE room-type.room-type = rt) THEN
    DO:
      roomType = rt.
      DISPLAY roomType WITH FRAME fMain.
      RUN check-availability (INPUT d1, INPUT d2).
    END.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check-availability fFrameWin 
PROCEDURE check-availability :
/*------------------------------------------------------------------------------
  Purpose:     Set start and end dates in UI and check room availability.
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

DEF INPUT PARAMETER checkIn AS DATE.
DEF INPUT PARAMETER checkOut AS DATE.

  startDate = checkIn.
  endDate = checkOut.
  DISPLAY startDate endDate WITH FRAME fMain.
  RUN refresh-days.  

  RUN refresh-avail-rooms.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-avail-rooms fFrameWin 
PROCEDURE refresh-avail-rooms :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR r-type AS INTEGER.
DEF VAR date1 AS DATE.
DEF VAR date2 AS DATE.
DEF VAR busy-reserv AS CHAR.
DEF VAR busy-stay AS CHAR.

r-type = roomType:INPUT-VALUE in frame fMain.
date1 = startDate:INPUT-VALUE in frame fMain.
date2 = endDate:INPUT-VALUE in frame fMain.

busy-reserv = "".
FOR EACH reservation NO-LOCK 
   WHERE NOT (reservation.end-date <= date1 OR date2 <= reservation.start-date):
   
   IF busy-reserv <> "" THEN DO:
     busy-reserv = busy-reserv + ",". 
   END.
   
   busy-reserv = busy-reserv + STRING(reservation.room-num).
END.

busy-stay = "".
FOR EACH stay NO-LOCK 
   WHERE NOT (stay.end-date <= date1 OR date2 <= stay.start-date):
   
   IF busy-stay <> "" THEN DO:
     busy-stay = busy-stay + ",". 
   END.
   
   busy-stay = busy-stay + STRING(stay.room-num).
END.

OPEN QUERY availRooms FOR EACH room NO-LOCK WHERE room.ACTIVE
   AND (IF r-type <> 0 THEN room.room-type = r-type ELSE TRUE)
   AND LOOKUP(STRING(room.room-num), busy-reserv) = 0
   AND LOOKUP(STRING(room.room-num), busy-stay) = 0,
   EACH room-type OF room NO-LOCK.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

