
def var roomPriceVal as integer init ?.

{calc-price-proc.i}

PROCEDURE calc-price :

DEF OUTPUT PARAMETER price AS DECIMAL INIT ?.
DEF OUTPUT PARAMETER err AS CHAR INIT ?.

DEF VAR num AS INTEGER.
num = roomNumber:INPUT-VALUE IN FRAME {1}.

FIND FIRST room WHERE room.room-num = num NO-ERROR.
IF NOT AVAIL(room) THEN DO:
   err = "Specify valid Room Number". 
   RETURN.
END.

{check-date.i {1}}

run calc-price-proc(input room.room-type, input date1, input date2, output price, output err).

END PROCEDURE.



PROCEDURE refresh-days-price :

RUN refresh-days.

DEF VAR price AS INT.
DEF VAR txt AS CHAR.
RUN calc-price(OUTPUT price, OUTPUT txt).

IF price <> ? THEN DO:
   txt = trim(string(price, "$ >>>,>>9.99")).
   roomPriceVal = price.
END.
else do:
   roomPriceVal = ?.
end.
priceText = txt.
DISPLAY priceText WITH FRAME {1}.

END PROCEDURE.

