/*------------------------------------------------------------------------
Description:    from cntnrdlg.w - SmartDialog Template
Arguments:      <none>
Comments:       
------------------------------------------------------------------------*/

package com.goldencode.hotel.common;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.common.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.SelfManager.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.util.TextOps.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adatesd0.w).
 */
public class Adatesd0
{
   public static final String FMT_STR_1 = ">9";

   public static final String FMT_STR_2 = "->,>>>,>>9";

   public static final String FMT_STR_3 = "9999";

   Adatesd0Dialogframe dialogframeFrame = GenericFrame.createFrame(Adatesd0Dialogframe.class, "dialogframe");

   character icTitle;

   date idtInputDate;

   date odtOutputDate;

   character[] lcMonthName = TypeFactory.characterExtent(12, "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");

   handle[] lhButton = TypeFactory.handleExtent(49);

   date ldtSelectedDate = TypeFactory.date();

   integer liSelectedDateIdx = TypeFactory.integer();

   handle lhTodayRectangle = TypeFactory.handle();

   integer liSelectedDay = TypeFactory.integer((long) 0);

   integer liSelectedMonth = TypeFactory.integer((long) 0);

   integer liSelectedYear = TypeFactory.integer((Long) null);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adatesd0.w).
    */
   public void execute(final character _icTitle, final date _idtInputDate, final date odtOutputDate)
   {
      character icTitle = TypeFactory.initInput(_icTitle);
      date idtInputDate = TypeFactory.initInput(_idtInputDate);
      /* Local Variable Definitions ---                                       */
      handle lFocusWh = TypeFactory.handle();
      
      externalProcedure(Adatesd0.this, new Block((Init) () -> 
      {
         Adatesd0.this.icTitle = icTitle;
         Adatesd0.this.idtInputDate = idtInputDate;
         TypeFactory.initOutput(odtOutputDate, new date());
         Adatesd0.this.odtOutputDate = odtOutputDate;
      }, 
      (Body) () -> 
      {
         dialogframeFrame.openScope();
         dialogframeFrame.asWidget().setScrollable(new logical(false));
         dialogframeFrame.setHidden(new logical(true));
         dialogframeFrame.widgetRectClassicBackground().setHidden(new logical(true));
         
         /* _RUN-TIME-ATTRIBUTES-END */
         /* ************************  Control Triggers  ************************ */
         registerTrigger(new EventList("WINDOW-CLOSE", dialogframeFrame /* Select Date */.asWidget()), Adatesd0.this, new Trigger((Body) () -> 
         {
            apply(self(), "END-ERROR");
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CHOOSE", dialogframeFrame.widgetBtnNextMonth()), TriggerBlock0.class, Adatesd0.this);
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CHOOSE", dialogframeFrame.widgetBtnNextYear()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", new date(liSelectedMonth, int64.minimum(fiDaysInMonthForDate(new date(new date(liSelectedMonth, 1, plus(liSelectedYear, 1)))), liSelectedDay), plus(liSelectedYear, 1)));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CHOOSE", dialogframeFrame.widgetBtnPrevMonth()), TriggerBlock1.class, Adatesd0.this);
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CHOOSE", dialogframeFrame.widgetBtnPrevYear()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", new date(liSelectedMonth, int64.minimum(fiDaysInMonthForDate(new date(new date(liSelectedMonth, 1, minus(liSelectedYear, 1)))), liSelectedDay), minus(liSelectedYear, 1)));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CHOOSE", dialogframeFrame.widgetBtnToday()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", date.today());
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("MOUSE-SELECT-DBLCLICK", dialogframeFrame.widgetBtnToday()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.widgetBtnOk().apply("CHOOSE");
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("ALT-T", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.widgetBtnToday().apply("CHOOSE");
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CHOOSE", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            odtOutputDate.assign(ldtSelectedDate);
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CURSOR-DOWN", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", date.plusDays(ldtSelectedDate, 7));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CURSOR-LEFT", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", date.minusDays(ldtSelectedDate, 1));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CURSOR-RIGHT", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", date.plusDays(ldtSelectedDate, 1));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("CURSOR-UP", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeWithMode("PSetDate", "I", date.minusDays(ldtSelectedDate, 7));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("PAGE-DOWN", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.widgetBtnNextMonth().apply("CHOOSE");
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("PAGE-UP", dialogframeFrame.widgetBtnOk()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.widgetBtnPrevMonth().apply("CHOOSE");
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("VALUE-CHANGED", dialogframeFrame.widgetLiSelectedDay()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.assignScreenValue(new Element(liSelectedDay, dialogframeFrame.widgetLiSelectedDay()));
            ControlFlowOps.invokeWithMode("PSetDate", "I", new date(liSelectedMonth, liSelectedDay, liSelectedYear));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("VALUE-CHANGED", dialogframeFrame.widgetLiSelectedMonth()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.assignScreenValue(new Element(liSelectedMonth, dialogframeFrame.widgetLiSelectedMonth()));
            /* Might have to adjust the date backwards if the current day is more than the value in the month */
            ControlFlowOps.invokeWithMode("PSetDate", "I", new date(liSelectedMonth, int64.minimum(liSelectedDay, fiDaysInMonthForDate(new date(new date(liSelectedMonth, 1, liSelectedYear)))), liSelectedYear));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         registerTrigger(new EventList("VALUE-CHANGED", dialogframeFrame.widgetLiSelectedYear()), Adatesd0.this, new Trigger((Body) () -> 
         {
            dialogframeFrame.assignScreenValue(new Element(liSelectedYear, dialogframeFrame.widgetLiSelectedYear()));
            /* Might have to adjust the date backwards if the current day is more than the value in the month - can only occur 
                for year combo if going from leap date to a non leap date */
            ControlFlowOps.invokeWithMode("PSetDate", "I", new date(liSelectedMonth, int64.minimum(liSelectedDay, fiDaysInMonthForDate(new date(new date(liSelectedMonth, 1, liSelectedYear)))), liSelectedYear));
         }));
         
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         /* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
         if (_and(activeWindow().isValid(), () -> isUnknown(dialogframeFrame.asWidget().getParentHandle())))
         {
            dialogframeFrame.asWidget().setParentHandle(activeWindow());
         }
         
         ControlFlowOps.invoke("PSetDialogCoordinates");
         
         OnPhrase[] onPhrase0 = new OnPhrase[]
         {
 /* TRANSACTION  Uncomment to have a dialog with transaction properties */            new OnPhrase(Condition.ERROR, Action.LEAVE, "mainBlock"),
            new OnPhrase(Condition.ENDKEY, Action.LEAVE, "mainBlock")
         };
         
         doBlock(TransactionType.SUB, "mainBlock", onPhrase0, new Block((Body) () -> 
         {
            /* Scope frame everywhere */
            ControlFlowOps.invoke("PInitialize");
            ControlFlowOps.invoke("enable_UI");
            
            if ((lFocusWh.isValid()).booleanValue())
            {
               LogicalTerminal.waitFor(dialogframeFrame, new EventList("GO", dialogframeFrame.asWidget()), (GenericWidget) lFocusWh.unwrapWidget());
            }
            else
            {
               LogicalTerminal.waitFor(dialogframeFrame, new EventList("GO", dialogframeFrame.asWidget()));
            }
         }));
         
         ControlFlowOps.invoke("disable_UI");
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     DISABLE the User Interface<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Here we clean-up the user-interface by deleting<br>
    *              dynamic widgets we have created and/or hide <br>
    *              frames.  This procedure is usually called when<br>
    *              we are ready to "clean-up" after running.
    */
   public void disableUi()
   {
      internalProcedure(new Block((Body) () -> 
      {
         /* Hide all frames. */
         dialogframeFrame.hide();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     ENABLE the User Interface<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Here we display/view/enable the widgets in the<br>
    *              user-interface.  In addition, OPEN all queries<br>
    *              associated with each FRAME and BROWSE.<br>
    *              These statements here are based on the "Other <br>
    *              Settings" section of the widget Property Sheets.
    */
   public void enableUi()
   {
      internalProcedure(new Block((Body) () -> 
      {
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(liSelectedDay, dialogframeFrame.widgetLiSelectedDay()),
            new Element(liSelectedMonth, dialogframeFrame.widgetLiSelectedMonth()),
            new Element(liSelectedYear, dialogframeFrame.widgetLiSelectedYear())
         };
         
         dialogframeFrame.display(elementList0);
         
         FrameElement[] elementList1 = new FrameElement[]
         {
            new WidgetElement(dialogframeFrame.widgetBtnNextMonth()),
            new WidgetElement(dialogframeFrame.widgetBtnNextYear()),
            new WidgetElement(dialogframeFrame.widgetBtnToday()),
            new WidgetElement(dialogframeFrame.widgetBtnPrevMonth()),
            new WidgetElement(dialogframeFrame.widgetBtnOk()),
            new WidgetElement(dialogframeFrame.widgetBtnCancel()),
            new WidgetElement(dialogframeFrame.widgetLiSelectedDay()),
            new WidgetElement(dialogframeFrame.widgetLiSelectedMonth()),
            new WidgetElement(dialogframeFrame.widgetLiSelectedYear()),
            new WidgetElement(dialogframeFrame.widgetBtnPrevYear()),
            new WidgetElement(dialogframeFrame.widgetRect1()),
            new WidgetElement(dialogframeFrame.widgetRectSelectedDate()),
            new WidgetElement(dialogframeFrame.widgetRect2()),
            new WidgetElement(dialogframeFrame.widgetRect3())
         };
         
         dialogframeFrame.enable(elementList1);
         
         dialogframeFrame.view();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pinitialize()
   {
      integer iRow = TypeFactory.integer();
      integer iCol = TypeFactory.integer();
      integer iCount = TypeFactory.integer();
      handle hFrame = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Title */
         if (_isGreaterThan(icTitle, ""))
         {
            dialogframeFrame.setTitle(icTitle);
         }
         
         loopLabel0:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, 7); iCount.increment())
         {
            DynamicWidgetFactory.createButton(subscript(lhButton, iCount));
            subscript(lhButton, iCount).unwrapCommonField().setLabel(entry(iCount, "Mon,Tue,Wed,Thu,Fri,Sat,Sun"));
            subscript(lhButton, iCount).unwrapWidget().setFrameHandle(dialogframeFrame.asWidgetHandle());
            subscript(lhButton, iCount).unwrapXY().setX(new integer(plus(9, multiply(minus(iCount, 1), plus(30, 2)))));
            subscript(lhButton, iCount).unwrapXY().setY(new integer(37));
            subscript(lhButton, iCount).unwrapButton().setFlatButton(new logical(true));
            subscript(lhButton, iCount).unwrapSizeable().setWidthPixels(new integer(30));
            subscript(lhButton, iCount).unwrapSizeable().setHeightPixels(new integer(20));
            subscript(lhButton, iCount).unwrapSensitive().setSensitive(new logical(true));
         }
         
         loopLabel1:
         for (iCount.assign(8); _isLessThanOrEqual(iCount, 49); iCount.increment())
         {
            iRow.assign(truncate(divide(minus(iCount, 1), 7), 0));
            iCol.assign(plus(modulo(minus(iCount, 1), 7), 1));
            /* MoFo Progress */
            DynamicWidgetFactory.createFrame(hFrame);
            hFrame.unwrapWidget().setFrameHandle(dialogframeFrame.asWidgetHandle());
            hFrame.unwrapXY().setX(new integer(plus(9, multiply(minus(iCol, 1), plus(30, 2)))));
            hFrame.unwrapXY().setY(new integer(plus(37, multiply(iRow, plus(20, 2)))));
            hFrame.unwrapSizeable().setWidthPixels(new integer(30));
            hFrame.unwrapSizeable().setHeightPixels(new integer(20));
            hFrame.unwrapBox().setBox(new logical(false));
            hFrame.unwrapWidget().setFont(dialogframeFrame.getFont());
            hFrame.unwrapWidget().setThreeD(new logical(true));
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DBLCLICK", hFrame), "PTrigger_DateDoubleClick", thisProcedure());
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DOWN", hFrame), "PTrigger_DateSelected", thisProcedure());
            DynamicWidgetFactory.createButton(subscript(lhButton, iCount));
            subscript(lhButton, iCount).unwrapWidget().setFrameHandle(hFrame);
            subscript(lhButton, iCount).unwrapXY().setX(new integer(0));
            subscript(lhButton, iCount).unwrapXY().setY(new integer(0));
            /*
                               X = {&BUTTON_X_OFFSET_PIXELS} + ((iCol - 1) * ({&BUTTON_WIDTH_PIXELS} + {&BUTTON_GAP_PIXELS}))
                               Y = {&BUTTON_Y_OFFSET_PIXELS} + (iRow * ({&BUTTON_HEIGHT_PIXELS} + {&BUTTON_GAP_PIXELS}))
                               */
            subscript(lhButton, iCount).unwrapButton().setFlatButton(new logical(true));
            subscript(lhButton, iCount).unwrapSizeable().setWidthPixels(new integer(30));
            subscript(lhButton, iCount).unwrapSizeable().setHeightPixels(new integer(20));
            subscript(lhButton, iCount).unwrapSensitive().setSensitive(new logical(true));
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DBLCLICK", subscript(lhButton, iCount)), "PTrigger_DateDoubleClick", thisProcedure());
            registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DOWN", subscript(lhButton, iCount)), "PTrigger_DateSelected", thisProcedure());
         }
         
         /* Year combo */
         dialogframeFrame.widgetLiSelectedYear().setListItems(new character(""));
         
         loopLabel2:
         for (iCount.assign(1850); _isLessThanOrEqual(iCount, 2150); iCount.increment())
         {
            dialogframeFrame.widgetLiSelectedYear().addLast(valueOf(iCount));
         }
         
         dialogframeFrame.widgetBtnToday().setTooltip(valueOf(date.today(), "99/99/9999"));
         dialogframeFrame.widgetRectSelectedDate().moveToTop();
         
         if (_isEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
         {
            dialogframeFrame.widgetRectClassicBackground().moveToBottom();
            dialogframeFrame.widgetRectClassicBackground().setVisible(new logical(true));
         }
         
         ControlFlowOps.invokeWithMode("PSetDate", "I", _or(or(isUnknown(idtInputDate), () -> isGreaterThan(date.year(idtInputDate), 2150)), () -> isLessThan(date.year(idtInputDate), 1850)) ? date.today() : idtInputDate);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void psetDate(final date _idtDate_1)
   {
      date idtDate_1 = TypeFactory.initInput(_idtDate_1);
      date dtFirstOfMonth = TypeFactory.date();
      integer iStartDay = TypeFactory.integer();
      integer iCount = TypeFactory.integer();
      date dtLoop = TypeFactory.date();
      integer iDaysInMonth = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         idtDate_1.assign(date.minimum(idtDate_1, date.fromLiteral("12/31/2150")));
         idtDate_1.assign(date.maximum(idtDate_1, date.fromLiteral("01/01/1850")));
         liSelectedDay.assign(date.day(idtDate_1));
         liSelectedMonth.assign(date.month(idtDate_1));
         liSelectedYear.assign(date.year(idtDate_1));
         
         if (_and(isEqual(date.month(ldtSelectedDate), date.month(idtDate_1)), () -> isEqual(date.year(ldtSelectedDate), date.year(idtDate_1))))
         {
            if (_isGreaterThan(liSelectedDateIdx, 0))
            {
               if (_isNotEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
               {
                  subscript(lhButton, liSelectedDateIdx).unwrapWidget().getFrameHandle().unwrapWidget().setBgColor(new integer(15));
               }
               else
               {
                  subscript(lhButton, liSelectedDateIdx).unwrapWidget().setFont(new integer(10));
               }
            }
            /* What's the new index? */
            liSelectedDateIdx.assign(plus(plus(date.differenceNum(idtDate_1, new date(subscript(lhButton, plus(1, 7)).unwrap().getPrivateData())), 1), 7));
         }
         else
         {
            if ((lhTodayRectangle.isValid()).booleanValue())
            {
               HandleOps.delete(lhTodayRectangle);
            }
            
            dtFirstOfMonth.assign(new date(date.month(idtDate_1), 1, date.year(idtDate_1)));
            /* iStartDay = ((WEEKDAY(dtFirstOfMonth) - 2) MODULO 7) + 1.  _* WEEKDAY -> Sunday = 1, we want Monday -> 1 *_ */
            iStartDay.assign(plus(modulo(minus(date.weekday(dtFirstOfMonth), 3), 7), 2));
            
            loopLabel3:
            for (iCount.assign(1); _isLessThanOrEqual(iCount, 42); iCount.increment())
            {
               dtLoop.assign(date.minusDays(date.plusDays(dtFirstOfMonth, iCount), iStartDay));
               subscript(lhButton, plus(iCount, 7)).unwrapWidget().setFont(new integer(10));
               subscript( /* in case TODAY was previously selected in classic mode */lhButton, plus(iCount, 7)).unwrapCommonField().setLabel(valueOf(date.day(dtLoop)));
               subscript(lhButton, plus(iCount, 7)).unwrap().setPrivateData(valueOf(dtLoop));
               subscript(lhButton, plus(iCount, 7)).unwrapWidget().getFrameHandle().unwrap().setPrivateData(valueOf(dtLoop));
               
               if (_isEqual(date.month(dtLoop), date.month(idtDate_1)))
               {
                  subscript(lhButton, plus(iCount, 7)).unwrapWidget().getFrameHandle().unwrapWidget().setBgColor(new integer(15));
                  
                  if (_isEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
                  {
                     subscript(lhButton, plus(iCount, 7)).unwrapSensitive().setSensitive(new logical(true));
                  }
               }
               else
               {
                  subscript(lhButton, plus(iCount, 7)).unwrapWidget().getFrameHandle().unwrapWidget().setBgColor(new integer(8));
                  
                  if (_isEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
                  {
                     subscript(lhButton, plus(iCount, 7)).unwrapSensitive().setSensitive(new logical(false));
                  }
               }
               
               /* This could be done with a single assign, but haven't yet worked out the logic */
               if (_isEqual(dtLoop, idtDate_1))
               {
                  liSelectedDateIdx.assign(plus(iCount, 7));
               }
               
               if (_isEqual(dtLoop, date.today()))
               {
                  DynamicWidgetFactory.createRectangle(lhTodayRectangle);
                  lhTodayRectangle.unwrapWidget().setFrameHandle(dialogframeFrame.asWidgetHandle());
                  lhTodayRectangle.unwrapXY().setX(new integer(minus(subscript(lhButton, plus(iCount, 7)).unwrapWidget().getFrameHandle().unwrapXY().getX(), 1)));
                  lhTodayRectangle.unwrapXY().setY(new integer(minus(subscript(lhButton, plus(iCount, 7)).unwrapWidget().getFrameHandle().unwrapXY().getY(), 1)));
                  lhTodayRectangle.unwrapSizeable().setWidthPixels(new integer(plus(30, 2)));
                  lhTodayRectangle.unwrapSizeable().setHeightPixels(new integer(plus(20, 2)));
                  lhTodayRectangle.unwrapRectangle().setEdgePixels(new integer(1));
                  lhTodayRectangle.unwrapWidget().setFgColor(new integer(12));
                  lhTodayRectangle.unwrapWidget().moveToTop();
               }
            }
            
            /* Reset days in month combo */
            iDaysInMonth.assign(fiDaysInMonthForDate(idtDate_1));
            /* LiSelectedDay:INPUT-VALUE = "". _* Cos we're going to refresh *_ */
            dialogframeFrame.widgetLiSelectedDay().setListItems(new character(""));
            
            loopLabel4:
            for (iCount.assign(1); _isLessThanOrEqual(iCount, iDaysInMonth); iCount.increment())
            {
               dialogframeFrame.widgetLiSelectedDay().addLast(valueOf(iCount));
            }
            
            /* "Accelerator" Tooltips */
            dialogframeFrame.widgetBtnPrevYear().setTooltip(valueOf(minus(liSelectedYear, 1)));
            dialogframeFrame.widgetBtnPrevMonth().setTooltip(subscript(lcMonthName, plus(modulo(minus(liSelectedMonth, 2), 12), 1)));
            dialogframeFrame.widgetBtnNextYear().setTooltip(valueOf(plus(liSelectedYear, 1)));
            dialogframeFrame.widgetBtnNextMonth().setTooltip(subscript(lcMonthName, plus(modulo(liSelectedMonth, 12), 1)));
         }
         
         if (_isNotEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
         {
            subscript(lhButton, liSelectedDateIdx).unwrapWidget().getFrameHandle().unwrapWidget().setBgColor(new integer(7));
         }
         else
         {
            subscript(lhButton, liSelectedDateIdx).unwrapWidget().setFont(new integer(6));
         }
         
         dialogframeFrame.widgetRectSelectedDate().setX(new integer(minus(subscript(lhButton, liSelectedDateIdx).unwrapWidget().getFrameHandle().unwrapXY().getX(), 1)));
         dialogframeFrame.widgetRectSelectedDate().setY(new integer(minus(subscript(lhButton, liSelectedDateIdx).unwrapWidget().getFrameHandle().unwrapXY().getY(), 1)));
         
         FrameElement[] elementList2 = new FrameElement[]
         {
            new Element(liSelectedDay, dialogframeFrame.widgetLiSelectedDay()),
            new Element(liSelectedMonth, dialogframeFrame.widgetLiSelectedMonth()),
            new Element(liSelectedYear, dialogframeFrame.widgetLiSelectedYear())
         };
         
         /* rectSelectedDate:MOVE-TO-TOP() IN FRAME {&FRAME-NAME}. */
         /*
             
             IF VALID-HANDLE(LhButtonSelectedDate)
             THEN DELETE OBJECT LhButtonSelectedDate.
                  
             
             CREATE BUTTON LhButtonSelectedDate
                 ASSIGN
                 
                 WIDTH-PIXELS = {&BUTTON_WIDTH_PIXELS}
                 HEIGHT-PIXELS = {&BUTTON_HEIGHT_PIXELS}
                 FRAME = LhButton[LiSelectedDateIdx]:FRAME
                 SENSITIVE = TRUE
                 LABEL = LhButton[LiSelectedDateIdx]:LABEL
                 VISIBLE = TRUE
                 .
             
             LhButtonSelectedDate:MOVE-TO-TOP().
             
             APPLY "ENTRY" TO LhButtonSelectedDate.
             */
         /* Display the combos */
         dialogframeFrame.display(elementList2);
         
         ldtSelectedDate.assign(idtDate_1);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     This is an attempt to position the dialog below the date fill-in.  <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       For some reason on the front office, it's not exactly right, but can't fathom why.
    */
   public void psetDialogCoordinates()
   {
      integer iWindowX = TypeFactory.integer();
      integer iWindowY = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      logical lAccountForMenuBar = TypeFactory.logical((Boolean) null);
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_and(and(and(focus().isValid(), () -> isEqual(focus().unwrapType().getResourceType(), "BUTTON")), () -> focus().unwrapWidget().getPreviousTabItem().isValid()), () -> isEqual(focus().unwrapWidget().getPreviousTabItem().unwrapType().getResourceType(), "FILL-IN")))
         {
            hObject.assign(focus().unwrapWidget().getPreviousTabItem());
            
            loopLabel5:
            while (_and(hObject.isValid(), () -> isEqual(hObject.unwrapWidget().getWindow(), focus().unwrapWidget().getWindow())))
            {
               iWindowX.assign(plus(iWindowX, hObject.unwrapXY().getX()));
               iWindowY.assign(plus(iWindowY, hObject.unwrapXY().getY()));
               
               /* {dbg.i hObject:TYPE hObject:X hObject:Y hObject:NAME hObject:WINDOW hObject:INSTANTIATING-PROCEDURE:NAME} */
               /*
                           hObject = hObject:PARENT NO-ERROR. _* FIELD-GROUP *_
                           hObject = hObject:PARENT NO-ERROR.
                           */
               if (_isEqual(hObject.unwrapType().getResourceType(), "DIALOG-BOX"))
               {
                  lAccountForMenuBar.assign(false);
               }
               
               ErrorManager.silentErrorEnable();
               hObject.assign(hObject.unwrapWidget().getFrameHandle());
               ErrorManager.silentErrorDisable();
            }
            
            if (_isUnknown(lAccountForMenuBar))
            {
               lAccountForMenuBar.assign(notUnknown(dialogframeFrame.asWidget().getWindow().unwrapWindow().getMenubar()));
            }
            
            dialogframeFrame.setX(new integer(plus(iWindowX, 8 /* + 5 */)));
            dialogframeFrame.setY(new integer(plus(iWindowY, ((lAccountForMenuBar).booleanValue() ? new integer(73) : new integer(53)))));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerDateDoubleClick()
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_isEqual(new date(self().unwrap().getPrivateData()), ldtSelectedDate) /* if haven't selected another month's date, which would have moved by now */)
         {
            dialogframeFrame.widgetBtnOk().apply("CHOOSE");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void ptriggerDateSelected()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeWithMode("PSetDate", "I", new date(self().unwrap().getPrivateData()));
         dialogframeFrame.widgetBtnOk().apply("ENTRY");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public integer fiDaysInMonthForDate(final date _idtDate_1)
   {
      date idtDate_1 = TypeFactory.initInput(_idtDate_1);
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  Just define lots of variables to make this as simple as possible
      ------------------------------------------------------------------------------*/
      integer iThisMonth = TypeFactory.integer();
      integer iThisYear = TypeFactory.integer();
      integer iNextMonth = TypeFactory.integer();
      integer iNextMonthsYear = TypeFactory.integer();
      
      return function("FiDaysInMonthForDate", integer.class, new Block((Body) () -> 
      {
         iThisMonth.assign(date.month(idtDate_1));
         iThisYear.assign(date.year(idtDate_1));
         iNextMonth.assign(plus(iThisMonth, 1));
         iNextMonthsYear.assign(iThisYear);
         
         if (_isEqual(iNextMonth, 13))
         {
            iNextMonth.assign(1);
            iNextMonthsYear.assign(plus(iNextMonthsYear, 1));
         }
         
         returnNormal(date.differenceNum(new date(iNextMonth, 1, iNextMonthsYear), new date(iThisMonth, 1, iThisYear)));
      }));
   }

   public class TriggerBlock0
   extends Trigger
   {
      integer iNextMonth = TypeFactory.integer();

      integer iNextMonthsYear = TypeFactory.integer();

      public void body()
      {
         iNextMonth.assign(plus(modulo(liSelectedMonth, 12), 1));
         iNextMonthsYear.assign(plus(liSelectedYear, (_isEqual(iNextMonth, 1) ? new integer(1) : new integer(0))));
         ControlFlowOps.invokeWithMode("PSetDate", "I", new date(iNextMonth, int64.minimum(fiDaysInMonthForDate(new date(new date(iNextMonth, 1, iNextMonthsYear))), liSelectedDay), iNextMonthsYear));
      }
   }

   public class TriggerBlock1
   extends Trigger
   {
      integer iPrevMonth = TypeFactory.integer();

      integer iPrevMonthsYear = TypeFactory.integer();

      public void body()
      {
         iPrevMonth.assign(plus(modulo(minus(liSelectedMonth, 2), 12), 1));
         iPrevMonthsYear.assign(minus(liSelectedYear, (_isEqual(iPrevMonth, 12) ? new integer(1) : new integer(0))));
         ControlFlowOps.invokeWithMode("PSetDate", "I", new date(iPrevMonth, int64.minimum(fiDaysInMonthForDate(new date(new date(iPrevMonth, 1, iPrevMonthsYear))), liSelectedDay), iPrevMonthsYear));
      }
   }
}
