package com.goldencode.hotel.dmo._temp;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with a temporary table.
 */
public interface TtRoomsUsed_1
extends Temporary
{
   /**
    * Getter: useDate
    * 
    * @return  useDate
    */
   public date getUseDate();

   /**
    * Setter: useDate
    * 
    * @param   useDate
    *          useDate
    */
   public void setUseDate(date useDate);

   /**
    * Getter: roomNum
    * 
    * @return  roomNum
    */
   public integer getRoomNum();

   /**
    * Setter: roomNum
    * 
    * @param   roomNum
    *          roomNum
    */
   public void setRoomNum(NumberType roomNum);

   /**
    * Getter: roomType
    * 
    * @return  roomType
    */
   public integer getRoomType();

   /**
    * Setter: roomType
    * 
    * @param   roomType
    *          roomType
    */
   public void setRoomType(NumberType roomType);

   /**
    * Getter: rate
    * 
    * @return  rate
    */
   public decimal getRate();

   /**
    * Setter: rate
    * 
    * @param   rate
    *          rate
    */
   public void setRate(NumberType rate);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends TtRoomsUsed_1, Buffer
   {
   }
}
