package com.goldencode.hotel.ui;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

public interface UpdateReservationDialogGdialog
extends CommonFrame
{
   public static final Class configClass = UpdateReservationDialogGdialogDef.class;

   public ButtonWidget widgetEndDatePicker();

   public character getGuestName();

   public void setGuestName(character parm);

   public void setGuestName(String parm);

   public void setGuestName(BaseDataType parm);

   public FillInWidget widgetGuestName();

   public character getRoomNumber();

   public void setRoomNumber(character parm);

   public void setRoomNumber(String parm);

   public void setRoomNumber(BaseDataType parm);

   public ComboBoxWidget widgetRoomNumber();

   public integer getNumberOfGuests();

   public void setNumberOfGuests(integer parm);

   public void setNumberOfGuests(int parm);

   public void setNumberOfGuests(BaseDataType parm);

   public RadioSetWidget widgetNumberOfGuests();

   public date getStartDate();

   public void setStartDate(date parm);

   public void setStartDate(BaseDataType parm);

   public FillInWidget widgetStartDate();

   public date getEndDate();

   public void setEndDate(date parm);

   public void setEndDate(BaseDataType parm);

   public FillInWidget widgetEndDate();

   public ButtonWidget widgetBtnOk();

   public ButtonWidget widgetBtnCancel();

   public ButtonWidget widgetStartDatePicker();

   public character getRoomType();

   public void setRoomType(character parm);

   public void setRoomType(String parm);

   public void setRoomType(BaseDataType parm);

   public TextWidget widgetRoomType();

   public integer getReservationDays();

   public void setReservationDays(integer parm);

   public void setReservationDays(int parm);

   public void setReservationDays(BaseDataType parm);

   public TextWidget widgetReservationDays();

   public character getPriceText();

   public void setPriceText(character parm);

   public void setPriceText(String parm);

   public void setPriceText(BaseDataType parm);

   public TextWidget widgetPriceText();

   public static class UpdateReservationDialogGdialogDef
   extends WidgetList
   {
      ButtonWidget endDatePicker = new ButtonWidget();

      FillInWidget guestName = new FillInWidget();

      ComboBoxWidget roomNumber = new ComboBoxWidget();

      RadioSetWidget numberOfGuests = new RadioSetWidget();

      FillInWidget startDate = new FillInWidget();

      FillInWidget endDate = new FillInWidget();

      ButtonWidget btnOk = new ButtonWidget();

      ButtonWidget btnCancel = new ButtonWidget();

      ButtonWidget startDatePicker = new ButtonWidget();

      TextWidget roomType = new TextWidget();

      TextWidget reservationDays = new TextWidget();

      TextWidget priceText = new TextWidget();

      public void setup(CommonFrame frame)
      {
         frame.setDown(1);
         frame.setDialogBox(true);
         frame.setKeepTabOrder(true);
         frame.setSideLabels(true);
         frame.setNoUnderline(true);
         frame.setThreeD(true);
         frame.setScrollable(true);
         frame.setFont(8);
         frame.setTitle("Update Reservation");
         frame.setDefaultButtonOption(btnOk);
         frame.setCancelButtonOption(btnCancel);
         endDatePicker.setImageUp("graphics/calendar.bmp");
         endDatePicker.setImageIns("graphics/calendar-disabled.bmp");
         endDatePicker.setNoFocus(true);
         endDatePicker.setWidthChars(6);
         endDatePicker.setHeightChars(1.19);
         endDatePicker.setRow(8.14);
         endDatePicker.setColumn(36.6);
         endDatePicker.setWidgetId(14);
         guestName.setDataType("character");
         guestName.setRow(1.48);
         guestName.setColumn(19);
         guestName.setAlign(ControlEntity.ALIGN_COLON);
         guestName.setWidgetId(2);
         roomNumber.setDataType("character");
         roomNumber.setRow(2.91);
         roomNumber.setColumn(19);
         roomNumber.setAlign(ControlEntity.ALIGN_COLON);
         roomNumber.setWidgetId(4);
         numberOfGuests.setDataType("integer");
         numberOfGuests.setRow(5.38);
         numberOfGuests.setColumn(3);
         numberOfGuests.setWidgetId(6);
         numberOfGuests.setForceLabel(true);
         numberOfGuests.setLabel("Number of Guests");
         startDate.setDataType("date");
         startDate.setRow(6.76);
         startDate.setColumn(19);
         startDate.setAlign(ControlEntity.ALIGN_COLON);
         startDate.setWidgetId(18);
         endDate.setDataType("date");
         endDate.setRow(8.19);
         endDate.setColumn(19);
         endDate.setAlign(ControlEntity.ALIGN_COLON);
         endDate.setWidgetId(16);
         btnOk.setAutoGoOption(true);
         btnOk.setWidthChars(15);
         btnOk.setHeightChars(1.14);
         btnOk.setRow(12.33);
         btnOk.setColumn(4);
         btnCancel.setAutoEndKeyOption(true);
         btnCancel.setWidthChars(15);
         btnCancel.setHeightChars(1.14);
         btnCancel.setRow(12.33);
         btnCancel.setColumn(21);
         startDatePicker.setImageUp("graphics/calendar.bmp");
         startDatePicker.setImageIns("graphics/calendar-disabled.bmp");
         startDatePicker.setNoFocus(true);
         startDatePicker.setWidthChars(6);
         startDatePicker.setHeightChars(1.19);
         startDatePicker.setRow(6.67);
         startDatePicker.setColumn(36.6);
         startDatePicker.setWidgetId(20);
         roomType.setDataType("character");
         roomType.setRow(4.33);
         roomType.setColumn(19);
         roomType.setAlign(ControlEntity.ALIGN_COLON);
         roomType.setWidgetId(22);
         reservationDays.setDataType("integer");
         reservationDays.setRow(9.62);
         reservationDays.setColumn(19);
         reservationDays.setAlign(ControlEntity.ALIGN_COLON);
         reservationDays.setWidgetId(24);
         priceText.setDataType("character");
         priceText.setRow(10.76);
         priceText.setColumn(19);
         priceText.setAlign(ControlEntity.ALIGN_COLON);
         priceText.setWidgetId(26);
         btnCancel.setLabel("Cancel");
         endDatePicker.setLabel("");
         roomNumber.setLabel("Room Number");
         roomNumber.setInitialInnerLines(5);
         roomNumber.setItems(new ControlSetItem[]
         {
            new ControlSetItem(new character("101"), new character("101")),
            new ControlSetItem(new character("102"), new character("102")),
            new ControlSetItem(new character("203"), new character("203")),
            new ControlSetItem(new character("204"), new character("204"))
         }, false);
         roomNumber.setModeDropDown(true);
         roomNumber.setWidthChars(16);
         roomNumber.setHeightChars(1);
         btnOk.setLabel("Update");
         endDate.setFormat("99/99/99");
         endDate.setLabel("Check-out Date");
         endDate.setWidthChars(14);
         endDate.setHeightChars(1);
         reservationDays.setFormat(">>>>>9");
         reservationDays.setLabel("Days");
         reservationDays.explicitViewAs(true);
         reservationDays.setWidthChars(14);
         reservationDays.setHeightChars(.62);
         startDatePicker.setLabel("");
         numberOfGuests.setHorizontal(true);
         numberOfGuests.setItems(new ControlSetItem[]
         {
            new ControlSetItem(new character("1"), new integer(1)),
            new ControlSetItem(new character("2"), new integer(2)),
            new ControlSetItem(new character("3"), new integer(3)),
            new ControlSetItem(new character("4"), new integer(4))
         }, true);
         numberOfGuests.setWidthChars(22);
         numberOfGuests.setHeightChars(.95);
         priceText.setFormat("X(256)");
         priceText.setLabel("Price");
         priceText.explicitViewAs(true);
         priceText.setWidthChars(48);
         priceText.setHeightChars(.62);
         startDate.setFormat("99/99/99");
         startDate.setLabel("Check-in Date");
         startDate.setWidthChars(14);
         startDate.setHeightChars(1);
         roomType.setFormat("X(256)");
         roomType.setLabel("Room Type");
         roomType.explicitViewAs(true);
         roomType.setWidthChars(34);
         roomType.setHeightChars(.62);
         guestName.setFormat("X(256)");
         guestName.setLabel("Guest Name");
         guestName.setWidthChars(41);
         guestName.setHeightChars(1);
      }

      {
         addWidget("endDatePicker", "endDatePicker", endDatePicker);
         addWidget("guestName", "guestName", guestName);
         addWidget("roomNumber", "roomNumber", roomNumber);
         addWidget("numberOfGuests", "numberOfGuests", numberOfGuests);
         addWidget("startDate", "startDate", startDate);
         addWidget("endDate", "endDate", endDate);
         addWidget("btnOk", "Btn_OK", btnOk);
         addWidget("btnCancel", "Btn_Cancel", btnCancel);
         addWidget("startDatePicker", "startDatePicker", startDatePicker);
         addWidget("roomType", "roomType", roomType);
         addWidget("reservationDays", "reservationDays", reservationDays);
         addWidget("priceText", "priceText", priceText);
      }
   }
}
