package com.goldencode.hotel.ui;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

public interface UpdateServiceDialogGdialog
extends CommonFrame
{
   public static final Class configClass = UpdateServiceDialogGdialogDef.class;

   public ButtonWidget widgetDatePicker();

   public integer getServiceType();

   public void setServiceType(integer parm);

   public void setServiceType(int parm);

   public void setServiceType(BaseDataType parm);

   public ComboBoxWidget widgetServiceType();

   public date getServiceDate();

   public void setServiceDate(date parm);

   public void setServiceDate(BaseDataType parm);

   public FillInWidget widgetServiceDate();

   public decimal getAmount();

   public void setAmount(decimal parm);

   public void setAmount(double parm);

   public void setAmount(BaseDataType parm);

   public FillInWidget widgetAmount();

   public ButtonWidget widgetBtnOk();

   public ButtonWidget widgetBtnCancel();

   public void setExpr7(character parm);

   public void setExpr7(String parm);

   public void setExpr7(BaseDataType parm);

   public LiteralWidget widgetExpr7();

   public static class UpdateServiceDialogGdialogDef
   extends WidgetList
   {
      ButtonWidget datePicker = new ButtonWidget();

      ComboBoxWidget serviceType = new ComboBoxWidget();

      FillInWidget serviceDate = new FillInWidget();

      FillInWidget amount = new FillInWidget();

      ButtonWidget btnOk = new ButtonWidget();

      ButtonWidget btnCancel = new ButtonWidget();

      LiteralWidget expr7 = new LiteralWidget();

      SkipEntity expr8 = new SkipEntity();

      SkipEntity expr9 = new SkipEntity();

      public void setup(CommonFrame frame)
      {
         frame.setDown(1);
         frame.setDialogBox(true);
         frame.setKeepTabOrder(true);
         frame.setSideLabels(true);
         frame.setNoUnderline(true);
         frame.setThreeD(true);
         frame.setScrollable(true);
         frame.setTitle("Add Service");
         frame.setDefaultButtonOption(btnOk);
         frame.setCancelButtonOption(btnCancel);
         datePicker.setImageUp("graphics/calendar.bmp");
         datePicker.setImageIns("graphics/calendar-disabled.bmp");
         datePicker.setNoFocus(true);
         datePicker.setWidthChars(6);
         datePicker.setHeightChars(1.19);
         datePicker.setRow(2.86);
         datePicker.setColumn(33);
         datePicker.setWidgetId(24);
         serviceType.setDbname("hotel");
         serviceType.setTable("service");
         serviceType.setDataType("integer");
         serviceType.setInitialInnerLines(5);
         serviceType.setItems(new ControlSetItem[]
         {
            new ControlSetItem(new character("test"), new integer(1))
         }, true);
         serviceType.setHonorFormat(false);
         serviceType.setModeDropDownList(true);
         serviceType.setWidthChars(34);
         serviceType.setHeightChars(1);
         serviceType.setRow(1.48);
         serviceType.setColumn(3.6);
         serviceType.setHelpStatic("");
         serviceType.setWidgetId(4);
         serviceDate.setDbname("hotel");
         serviceDate.setTable("service");
         serviceDate.setDataType("date");
         serviceDate.setWidthChars(14);
         serviceDate.setHeightChars(1);
         serviceDate.setRow(2.91);
         serviceDate.setColumn(15.4);
         serviceDate.setAlign(ControlEntity.ALIGN_COLON);
         serviceDate.setHelpStatic("");
         serviceDate.setWidgetId(6);
         amount.setDbname("hotel");
         amount.setTable("service");
         amount.setDataType("decimal");
         amount.setWidthChars(14);
         amount.setHeightChars(1);
         amount.setRow(4.33);
         amount.setColumn(15.4);
         amount.setAlign(ControlEntity.ALIGN_COLON);
         amount.setHelpStatic("");
         amount.setWidgetId(8);
         btnOk.setAutoGoOption(true);
         btnOk.setWidthChars(15);
         btnOk.setHeightChars(1.14);
         btnOk.setRow(6.1);
         btnOk.setColumn(3);
         btnCancel.setAutoEndKeyOption(true);
         btnCancel.setWidthChars(15);
         btnCancel.setHeightChars(1.14);
         btnCancel.setRow(6.1);
         btnCancel.setColumn(20.2);
         expr7.setDataType("character");
         expr7.setFormat("x(1)");
         ((UpdateServiceDialogGdialog) frame).setExpr7(new character("$"));
         expr7.explicitViewAs(true);
         expr7.setWidthChars(4);
         expr7.setHeightChars(.62);
         expr7.setRow(4.48);
         expr7.setColumn(32.8);
         expr7.setWidgetId(10);
         expr8.setVertical(false);
         expr8.setWidth(17.39);
         expr9.setVertical(true);
         expr9.setHeight(2.70);
         serviceDate.setDbname("hotel");
         serviceDate.setTable("service");
         amount.setDbname("hotel");
         amount.setTable("service");
         serviceDate.setDbname("hotel");
         serviceDate.setTable("service");
         amount.setDbname("hotel");
         amount.setTable("service");
         serviceType.setDbname("hotel");
         serviceType.setTable("service");
         serviceDate.setDbname("hotel");
         serviceDate.setTable("service");
         amount.setDbname("hotel");
         amount.setTable("service");
         serviceType.setFormat("->,>>>,>>9");
         serviceType.setLabel("Service Type");
         serviceType.setColumnLabel("Service Type");
         btnCancel.setLabel("Cancel");
         amount.setFormat("->>,>>9.99");
         amount.setLabel("Charge Amount");
         amount.setColumnLabel("Charge Amount");
         btnOk.setLabel("OK");
         serviceDate.setFormat("99/99/99");
         serviceDate.setLabel("Date");
         serviceDate.setColumnLabel("Date");
         datePicker.setLabel("");
      }

      {
         addWidget("datePicker", "datePicker", datePicker);
         addWidget("serviceType", "service-type", serviceType);
         addWidget("serviceDate", "service-date", serviceDate);
         addWidget("amount", "amount", amount);
         addWidget("btnOk", "Btn_OK", btnOk);
         addWidget("btnCancel", "Btn_Cancel", btnCancel);
         addWidget("expr7", "", expr7);
         addWidget("expr8", "", expr8);
         addWidget("expr9", "", expr9);
      }
   }
}
